// bound.cpp -definition of Bound class

#include "bound.h"
#include "calc.h"
#include <math.h>

Bound::Bound() {
    empty();
}

void Bound::empty() {
    minx=miny=minz=1e37;
    maxx=maxy=maxz=-1e37;
}

void Bound::include(Vec3& v) {
    if(v.x>maxx) maxx=v.x;
    if(v.x<minx) minx=v.x;

    if(v.y>maxy) maxy=v.y;
    if(v.y<miny) miny=v.y;

    if(v.z>maxz) maxz=v.z;
    if(v.z<minz) minz=v.z;
}

void Bound::include(Vec2& v) {
    if(v.u>maxx) maxx=v.u;
    if(v.u<minx) minx=v.u;

    if(v.v>maxy) maxy=v.v;
    if(v.v<miny) miny=v.v;
}

float Bound::size() {
    return sqrtf( (maxx-minx)*(maxx-minx) + (maxy-miny)*(maxy-miny) + (maxz-minz)*(maxz-minz));
}

