// dialex.cpp -- implementes the Dialex class

#include <windows.h>
#include "funcs.h"
#include "bone.h"
#include "tint.h"
#include "dialex.h"
#include "transform.h"

Dialex::Dialex() : first(0) { }

Dialex::~Dialex() {
    DialexData *dd;
    
    while(first!=0) {
        dd=first->next;
        delete first;
        first=dd;
    }
}

bool Dialex::isValid(int dlgItem) {
    DialexData *dd;

    for(dd=first;dd!=0;dd=dd->next)
        if(dd->item==dlgItem)
        return dd->valid;

    return false;
}

////// Flag functions

int Dialex::getDialogFlag(int dlgItem) {
    DialexData *dd;

    for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_FLG)
        if(dd->item==dlgItem)
                if(dd->valid)
        return (dd->data.fdata==0)?FALSE:TRUE;
    }
    return FALSE;
}

bool Dialex::setDialogFlag(int dlgItem,int value) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_FLG)
        if(dd->item==dlgItem) {
                dd->data.idata=((value==0)?FALSE:TRUE);
                        dd->valid=true;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_FLG;
        dd->item=dlgItem;
    dd->data.idata=((value==0)?FALSE:TRUE);
        dd->valid=true;
        return true;
}

bool Dialex::setInvalidFlag(int dlgItem) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_FLG)
        if(dd->item==dlgItem) {
                        dd->valid=false;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_FLG;
        dd->item=dlgItem;
        dd->valid=false;
        return true;
}

////// Float functions

float Dialex::getDialogFloat(int dlgItem) {
    DialexData *dd;

    for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_NUM)
        if(dd->item==dlgItem)
                if(dd->valid)
        return dd->data.fdata;
    }

    return 0.0;
}

bool Dialex::setDialogFloat(int dlgItem,float value) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_NUM)
        if(dd->item==dlgItem) {
                dd->data.fdata=value;
                        dd->valid=true;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_NUM;
        dd->item=dlgItem;
        dd->data.fdata=value;
        dd->valid=true;
        return true;
}

bool Dialex::setInvalidFloat(int dlgItem) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_NUM)
        if(dd->item==dlgItem) {
                        dd->valid=false;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_NUM;
        dd->item=dlgItem;
        dd->valid=false;
        return true;
}

////// Integer functions

int     Dialex::getDialogInteger(int dlgItem) {
    DialexData *dd;

    for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_INT)
        if(dd->item==dlgItem)
                if(dd->valid)
        return dd->data.idata;
    }
    return 0;
}

bool Dialex::setDialogInteger(int dlgItem,int value) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_INT)
        if(dd->item==dlgItem) {
                dd->data.idata=value;
                        dd->valid=true;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;
        
        dd->type=DXT_INT;
        dd->item=dlgItem;
        dd->data.idata=value;
        dd->valid=true;
        return true;
}

/* not needed yet
bool Dialex::setInvalidInteger(int dlgItem) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_INT)
        if(dd->item==dlgItem) {
                        dd->valid=false;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_INT;
        dd->item=dlgItem;
        dd->valid=false;
        return true;
}
*/

///// String functions

char* Dialex::getDialogString(int dlgItem) {
    DialexData *dd;

    for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_TXT)
        if(dd->item==dlgItem)
                if(dd->valid)
        return CloneString(dd->data.tdata);
    }
    return NULL;
}

bool Dialex::setDialogString(int dlgItem,char* value) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_TXT)
        if(dd->item==dlgItem) {
                        delete [](dd->data.tdata);
                dd->data.tdata=CloneString(value);
                        dd->valid=true;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_TXT;
        dd->item=dlgItem;
    dd->data.tdata=CloneString(value);
        dd->valid=true;
        return true;
}

// setInvalidString() not needed yet

////// Label functions

// no getLabel version--labels aren't returned

bool Dialex::setDialogLabel(int dlgItem,char* value) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_LBL)
        if(dd->item==dlgItem) {
                        delete [](dd->data.tdata);
                dd->data.tdata=CloneString(value);
                        dd->valid=true;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_LBL;
        dd->item=dlgItem;
    dd->data.tdata=CloneString(value);
        dd->valid=true;
        return true;
}

// no SetInvalid version -- not needed

////// Vector functions

// get version not needed

bool Dialex::setDialogVector(int dlgItem,Vec3& value) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_VEC)
        if(dd->item==dlgItem) {
                dd->data.vdata=(float*)&value;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_VEC;
        dd->item=dlgItem;
        dd->data.vdata=(float*)&value;
        return true;
}

// setInvalid version not needed

////// Matrix functions

// no get version

bool Dialex::setDialogMatrix(int dlgItem,Matrix* value) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_MAT)
        if(dd->item==dlgItem) {
                dd->data.mdata=value;
                        dd->valid=true;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_MAT;
        dd->item=dlgItem;
        dd->data.mdata=value;
        dd->valid=true;
        return true;
}

//no setInvalid version

////// Object functions

void *Dialex::getDialogObject(int dlgItem) {
    DialexData *dd;

    for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_OBJ)
        if(dd->item==dlgItem)
                if(dd->valid)
        return dd->data.odata;
    }
    return 0;
}

bool Dialex::setDialogObject(int dlgItem,void* value) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_OBJ)
        if(dd->item==dlgItem) {
                dd->data.odata=value;
                        dd->valid=true;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_OBJ;
        dd->item=dlgItem;
        dd->data.odata=value;
        dd->valid=true;
        return true;
}

// no setInvalid function yet

////// Bone functions

Bone* Dialex::getDialogBone(int dlgItem) {
    DialexData *dd;

    for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_BONE)
        if(dd->item==dlgItem)
        return dd->data.bdata;
    }
    return 0;
}

bool Dialex::setDialogBone(int dlgItem,Bone* value) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_BONE)
        if(dd->item==dlgItem) {
                dd->data.bdata=value;
                        dd->valid=true;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_BONE;
        dd->item=dlgItem;
        dd->data.bdata=value;
        dd->valid=true;
        return true;
}

bool Dialex::setInvalidBone(int dlgItem) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_BONE)
        if(dd->item==dlgItem) {
                        dd->valid=false;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_BONE;
        dd->item=dlgItem;
        dd->valid=false;
        return true;
}

////// Tint functions

Tint* Dialex::getDialogTint(int dlgItem) {
    DialexData *dd;

    for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_TINT)
        if(dd->item==dlgItem)
        return dd->data.tidata;
    }
    return 0;
}

bool Dialex::setDialogTint(int dlgItem,Tint* value) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_TINT)
        if(dd->item==dlgItem) {
                dd->data.tidata=value;
                        dd->valid=true;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_TINT;
        dd->item=dlgItem;
        dd->data.tidata=value;
        dd->valid=true;
        return true;
}

bool Dialex::setInvalidTint(int dlgItem) {
        DialexData *dd;

// update existing dlgItem, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_TINT)
        if(dd->item==dlgItem) {
                        dd->valid=false;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_TINT;
        dd->item=dlgItem;
        dd->valid=false;
        return true;
}

////// the stuff called by the dialog function

void Dialex::initializeDialogData(HWND hwnd) {
        DialexData *dd;
        int j;

        for(dd=first;dd!=0;dd=dd->next)
        switch(dd->type) {
                case DXT_INT:
                        if(dd->valid) {
                                SetDlgItemInt(hwnd,dd->item,dd->data.idata,TRUE);
                        } else {
                SetDlgItemText(hwnd,dd->item,"");
                        }
                break;
                case DXT_NUM:
                        if(dd->valid) {
                                SetDlgItemFloat(hwnd,dd->item,dd->data.fdata);
                        } else {
                SetDlgItemText(hwnd,dd->item,"");
                        }
                break;
                case DXT_VEC:
                        SetDlgItemFloat(hwnd,dd->item+X,dd->data.vdata[X]);
                        SetDlgItemFloat(hwnd,dd->item+Y,dd->data.vdata[Y]);
                        SetDlgItemFloat(hwnd,dd->item+Z,dd->data.vdata[Z]);
                break;
                case DXT_MAT:
                        for(j=0;j<12;j++)
                        SetDlgItemFloat(hwnd,dd->item+j,dd->data.vdata[j]);
                break;
                case DXT_LBL:
                case DXT_TXT:
                        if(dd->valid)
                        if(dd->item==0) {
                                SetWindowText(hwnd,dd->data.tdata);
                        } else {
                                SetDlgItemText(hwnd,dd->item,dd->data.tdata);
                        }
                break;
                case DXT_FLG:
                        if(dd->valid) {
                                CheckDlgButton(hwnd,dd->item,(dd->data.idata!=0)?BST_CHECKED:BST_UNCHECKED);
                        } else {
                                CheckDlgButton(hwnd,dd->item,BST_INDETERMINATE);
                        }
                break;
                case DXT_BONE:
                        if(dd->valid) {
                                if(dd->data.bdata) {
                                        j=(int)SendDlgItemMessage(hwnd,dd->item,CB_FINDSTRINGEXACT,(WPARAM)-1,
                                                (LPARAM)(dd->data.bdata->data.Name.c_string()));
                                } else {
                                        j=0;
                                }
                                SendDlgItemMessage(hwnd,dd->item,CB_SETCURSEL,j,0);
                        } else {
                                SendDlgItemMessage(hwnd,dd->item,CB_SETCURSEL,(WPARAM)-1,0);
                        }
                break;
                case DXT_TINT:
                        if(dd->valid) {
                                if(dd->data.tidata) {
                                        j=(int)SendDlgItemMessage(hwnd,dd->item,CB_FINDSTRINGEXACT,(WPARAM)-1,
                                                (LPARAM)(dd->data.tidata->data.Name.c_string()));
                                } else {
                                        j=0;
                                }
                                SendDlgItemMessage(hwnd,dd->item,CB_SETCURSEL,j,0);
                        } else {
                                SendDlgItemMessage(hwnd,dd->item,CB_SETCURSEL,(WPARAM)-1,0);
                        }
                break;
        }
}

void Dialex::returnDialogData(HWND hwnd) {
        DialexData *dd;
        int /* i, */ j;
//      char buff[32];

        for(dd=first;dd!=0;dd=dd->next)
        switch(dd->type) {
                case DXT_INT:
                        if(SendDlgItemMessage(hwnd,dd->item,WM_GETTEXTLENGTH,0,0)==0) {
                                dd->valid=false;
                        } else {
                                dd->data.idata=GetDlgItemInt(hwnd,dd->item,NULL,TRUE);
                                dd->valid=true;
                        }
                break;
                case DXT_TXT:
                        if(dd->data.tdata) { // destroy old string if there is one
                                delete [](dd->data.tdata);
                                dd->data.tdata=0;
                                dd->valid=false;
                        }
                        j=(int)SendDlgItemMessage(hwnd,dd->item,WM_GETTEXTLENGTH,0,0);
                        if(j!=0) {
                                dd->data.tdata=new char[j+1]; // allocate room for string
                                GetDlgItemText(hwnd , dd->item , dd->data.tdata , j+1); // get string
                                dd->valid=true;
                        }
                break;
                case DXT_NUM:
                        if(SendDlgItemMessage(hwnd,dd->item,WM_GETTEXTLENGTH,0,0)==0) {
                                dd->valid=false;
                        } else {
                                dd->data.fdata=GetDlgItemFloat(hwnd,dd->item);
                                dd->valid=true;
                        }
                break;
                case DXT_VEC:
                        dd->data.vdata[X]=GetDlgItemFloat(hwnd,dd->item+X);
                        dd->data.vdata[Y]=GetDlgItemFloat(hwnd,dd->item+Y);
                        dd->data.vdata[Z]=GetDlgItemFloat(hwnd,dd->item+Z);
                break;
                case DXT_MAT:
                        for(j=0;j<12;j++)
                        dd->data.vdata[j]=GetDlgItemFloat(hwnd,dd->item+j);
                break;
                case DXT_FLG:
                        switch (IsDlgButtonChecked(hwnd,dd->item)) {
                                case BST_CHECKED:
                                        dd->data.idata=TRUE;
                                        dd->valid=true;
                                break;
                                case BST_UNCHECKED:
                                        dd->data.idata=FALSE;
                                        dd->valid=true;
                                break;
                                case BST_INDETERMINATE:
                                        dd->valid=false;
                                break;
                        }
                break;
                case DXT_BONE:
                        j=(int)SendDlgItemMessage(hwnd,dd->item,CB_GETCURSEL,0,0);
                        if(j==CB_ERR) {
                                dd->valid=false;
                        } else {
                                dd->valid=true;
                                dd->data.bdata=(Bone*)SendDlgItemMessage(hwnd,dd->item,
                                        CB_GETITEMDATA,j,0);
                        }
                break;
                case DXT_TINT:
                        j=(int)SendDlgItemMessage(hwnd,dd->item,CB_GETCURSEL,0,0);
                        if(j==CB_ERR) {
                                dd->valid=false;
                        } else {
                                dd->valid=true;
                                dd->data.tidata=(Tint*)SendDlgItemMessage(hwnd,dd->item,
                                        CB_GETITEMDATA,j,0);
                        }
                break;
        }
}

DialexData::~DialexData() {

        switch(type) {
//              case DXT_INT:
//              case DXT_NUM:
//              case DXT_LBL:
                        // passed data is static, not dynamic
//              break;
                case DXT_TXT:
                case DXT_LBL:
                        delete [](data.tdata);
                break;
        }
}

bool Dialex::setDialogProject(class Project* p) {
        DialexData *dd;

// update existing project reference, if there is one
        for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_PROJECT) {
                dd->data.odata=p;
                        return true;
                }
        }

// if not, create a new one
        dd=new DialexData;
        if(dd==0) return false;

// place at head of linked list
        dd->next=first;
        first=dd;

        dd->type=DXT_PROJECT;
        dd->item=0;
        dd->data.odata=p;
        return true;
}

Project* Dialex::getDialogProject() {
    DialexData *dd;

    for(dd=first;dd!=0;dd=dd->next) {
        if(dd->type==DXT_PROJECT)
        return (Project*)(dd->data.odata);
    }
    return 0;
}
