#ifndef DIALEX_H
#define DIALEX_H

struct DialexData {
    DialexData *next;
        short   type;
        int             item;
//      unsigned short  control_type;   // the type of control to be used
        bool    valid;        // use or ignore data
        union {
                char    *tdata;
                int             idata;
                float   fdata;
                float*  vdata;
                COLORREF        cdata;
                void    *odata;
                Bone*   bdata;
                Tint*   tidata;
                Matrix* mdata;
        } data;
//      DialexData();
        ~DialexData();
};

class Dialex {
    public:
    DialexData *first;
    Dialex();
//      Dialex(class Vert*);
    ~Dialex();

        bool    isValid(int);

    int         getDialogFlag(int);
    bool        setDialogFlag(int,int);
    bool        setInvalidFlag(int);

    float       getDialogFloat(int);
    bool        setDialogFloat(int,float);
    bool        setInvalidFloat(int);

    int         getDialogInteger(int);
    bool        setDialogInteger(int,int);
//    bool      setInvalidInteger(int);

        bool    setDialogLabel(int,char*);              // no get or invalid version

        bool    setDialogMatrix(int,Matrix*);   // no get or invalid version

    void*       getDialogObject(int);
        bool    setDialogObject(int,void*);
        // no invalid version

        class Project*  getDialogProject();
        bool    setDialogProject(class Project*);
        // no invalid version

        char*   getDialogString(int);
        bool    setDialogString(int,char*);
        // no invalid version

        // no get version
        bool    setDialogVector(int,Vec3&);
        // no invalid version

        Bone*   getDialogBone(int);
        bool    setDialogBone(int,Bone*);
        bool    setInvalidBone(int);

        Tint*   getDialogTint(int);
        bool    setDialogTint(int,Tint*);
        bool    setInvalidTint(int);

    void        initializeDialogData(HWND);
    void        returnDialogData(HWND);

// these functions are for a properties dialog box that is built from specs given
// by the client code.  This allows the whole thing to be built as needed, and
// use a simplified dialog box design.

// first argument: control id
// second argument: value to be passed
// third argument: true if value is valid, false if not
// fourth arugment:  The type of control
// fifth argument:  The label for the control
//      bool    addDialogFlag(int,int,bool,unsigned short,char*);
//      bool    addDialogFloat(int,float,bool,unsigned short,char*);
//      bool    addDialogInt(int,int,bool,unsigned short,char*);
//      bool    addDialogObject(int,void*,bool,unsigned short,char*);
//      bool    addDialogString(int,char*,bool,unsigned short,char*);
};

#define DXT_INT 0       // an integer
#define DXT_TXT 1       // a string
#define DXT_NUM 2       // a float
#define DXT_RGB 3       // a COLORREF
#define DXT_LBL 4       // a label for the dialog box (or the title)
#define DXT_VEC 5       // the pointer to an XYZ vector
#define DXT_FLG 6       // a flag
#define DXT_OBJ 7       // a object
#define DXT_MAT 8       // a matrix
#define DXT_PROJECT 9   //  a model pointer (used for passing the affected model)
#define DXT_BONE    10  //  pointer to a Bone object
#define DXT_TINT    11  //  pointer to a Bone object

#endif
