#include "userint.h"
#include <commctrl.h>
#include <stdio.h>
#include "model.h"
#include "bone.h"
#include "vert.h"
#include "face.h"
#include "tint.h"
#include "dialex.h"
#include "lsmres.h"
#include "funcs.h"
#include "appdata.h"

void SetTintDialogControls(HWND,Tint*,bool);

#define SETCHECK(i,t) SendMessage(GetDlgItem(hwnd,i),BM_SETCHECK,\
        (WPARAM)(t?BST_CHECKED:BST_UNCHECKED),(LPARAM)0)

#define TESTCHECK(i) (SendMessage(GetDlgItem(hwnd,i),BM_GETCHECK,\
        (WPARAM)0,(LPARAM)0)==BST_CHECKED)

const float IDENTITY[12]={1.0,0.0,0.0, 0.0,1.0,0.0, 0.0,0.0,1.0, 0.0,0.0,0.0 };

const int m_id[12]={
        EB_VECXX,EB_VECXY,EB_VECXZ,
        EB_VECYX,EB_VECYY,EB_VECYZ,
        EB_VECZX,EB_VECZY,EB_VECZZ,
        EB_VECLX,EB_VECLY,EB_VECLZ
};

COLORREF colors[16];

CHOOSECOLOR cc= {
        sizeof(CHOOSECOLOR),
        NULL,NULL,
        RGB(128,128,128),
        colors,
        CC_RGBINIT,
        (LPARAM)0,
        NULL,
        NULL} ;

void SetDlgItemFloat(HWND hwnd,int DlgItem,float Val) {
        char numBuff[20];
        sprintf(numBuff,"%g",Val);
        SetDlgItemText(hwnd,DlgItem,numBuff);
}

float GetDlgItemFloat(HWND hwnd,int DlgItem) {
        char numBuff[20];
        GetDlgItemText(hwnd,DlgItem,numBuff,20);
        numBuff[19]=0;
        return (float)atof(numBuff);
}

void FillWindow(HWND hwnd,COLORREF cr) {
        RECT trect;
        HBRUSH hbr;
        HDC tdc;

        GetClientRect(hwnd,&trect);
        tdc=GetDC(hwnd);
        hbr=CreateSolidBrush(cr);

        FillRect(tdc,&trect,hbr);

        DrawEdge(tdc,&trect,EDGE_SUNKEN,BF_RECT);

        ReleaseDC(hwnd,tdc);
        DeleteObject(hbr);
}

BOOL _stdcall AboutDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM /* lParam */ ) {
        switch(msg) {
                case WM_CLOSE:
                        EndDialog(hwnd,0);
                        return 1;
                case WM_COMMAND:
                        switch (LOWORD(wParam)) {
                                case IDOK:
                                        EndDialog(hwnd,1);
                                        return 1;
                        }
                        break;
        }
        return 0;
}

BOOL _stdcall EditBoneDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
        static Dialex*  dx;
        static Bone*    b;
        static Model*   m;
        char InputBuffer[64];

//      short i;
        switch(msg) {
                case WM_INITDIALOG:
                        dx=(Dialex*)lParam;
                        b=(Bone*)dx->getDialogObject(0);
                        m=(Model*)dx->getDialogProject();
//                      m->buildBoneComboBox(hwnd,CB_OWNER,b);
                        dx->initializeDialogData(hwnd);
                        if(b==NULL) SetWindowText(hwnd,"NULL Bone*");
                return TRUE;
                case WM_CLOSE:
                        EndDialog(hwnd,0);
                        return 1;
                case WM_COMMAND:
                        switch (LOWORD(wParam)) {
                                case IDRETRY:
                                        dx->initializeDialogData(hwnd);
                                return TRUE;
                                case IDOK:
                                        if(GetDlgItemFloat(hwnd,EB_SCALEX)==0.0
                                        || GetDlgItemFloat(hwnd,EB_SCALEY)==0.0
                                        || GetDlgItemFloat(hwnd,EB_SCALEZ)==0.0 ) {
                                                MessageBoxEx(hwnd,"Scale factors cannot be zero.","Rejected",MB_OK,LANG_NEUTRAL);
                                                return TRUE;
                                        }
                                        GetDlgItemText(hwnd,EB_NAME,InputBuffer,63);
                                        if(strlen(InputBuffer)==0) {
                                                MessageBoxEx(hwnd,"Bones must have names.","Rejected",MB_OK,LANG_NEUTRAL);
                                                return TRUE;
                                        }
                                        if(m->isUniqueBoneName(InputBuffer,b)==false) {
                                                MessageBoxEx(hwnd,"There is already a bone by that name.","Rejected",MB_OK,LANG_NEUTRAL);
                                                return TRUE;
                                        }
                                        dx->returnDialogData(hwnd);
                                case IDCANCEL:
                                        EndDialog(hwnd,LOWORD(wParam));
                                return TRUE;
                                case CB_LOCKL:
                                        if(HIWORD(wParam)==BN_CLICKED) {
                                                switch(SendDlgItemMessage(hwnd,CB_LOCKL,BM_GETCHECK,0,0)) {
                                                        case BST_CHECKED:
                                                                SendDlgItemMessage(hwnd,CB_LOCKL,BM_SETCHECK,BST_UNCHECKED,0);
                                                        break;
                                                        default:
                                                                SendDlgItemMessage(hwnd,CB_LOCKL,BM_SETCHECK,BST_CHECKED,0);
                                                }
                                        }
                                        return TRUE;
                        }
                break;
        }
        return 0;
}

BOOL _stdcall ReparentDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
        static Dialex*  dx;
        static Bone*    b;
        static Model*   m;

//      short i;
        switch(msg) {
                case WM_INITDIALOG:
                        dx=(Dialex*)lParam;
                        b=(Bone*)dx->getDialogObject(0);
                        m=(Model*)dx->getDialogProject();
                        m->buildBoneComboBox(hwnd,CB_OWNER,b);
                        dx->initializeDialogData(hwnd);
//                      if(b==NULL) SetWindowText(hwnd,"NULL Bone*");
                return TRUE;
                case WM_CLOSE:
                        EndDialog(hwnd,0);
                        return 1;
                case WM_COMMAND:
                        switch (LOWORD(wParam)) {
                                case IDRETRY:
                                        dx->initializeDialogData(hwnd);
                                return TRUE;
                                case IDOK:
                                        dx->returnDialogData(hwnd);
                                case IDCANCEL:
                                        EndDialog(hwnd,LOWORD(wParam));
                                return TRUE;
                        }
                break;
        }
        return 0;
}

BOOL _stdcall EditVertDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
        static Model*   m;
        static Dialex*  dx;
//      MYPTR mp;
//      float value;
//      int index;
//      INDEX   version;

//      short i;
        switch(msg) {
                case WM_INITDIALOG:
                        // cache the model pointer
                        dx=(Dialex*)lParam;
                        m=(Model*)dx->getDialogProject();

                        // set up the check box for 3 states
                        SendDlgItemMessage(hwnd,CB_LOCKL,BM_SETSTYLE,BS_3STATE,TRUE);

                        // set up the Owner pulldown box
                        m->buildBoneComboBox(hwnd,CB_OWNER,(Bone*)0);

                        dx->initializeDialogData(hwnd);

                        return TRUE;

                case WM_COMMAND:
                        switch(LOWORD(wParam)) {
                                case IDOK:
                                        dx->returnDialogData(hwnd);
                                case IDCANCEL:
                                        EndDialog(hwnd,LOWORD(wParam));
                                return TRUE;
                                case IDRETRY:
                                        dx->initializeDialogData(hwnd);
                                return TRUE;
                        }
                        return TRUE;
        }
        return 0;
}

BOOL _stdcall EditFaceDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
        static Model*   m;
        static Dialex*  dx;
//      MYPTR mp;
//      float value;
//      int index;
//      INDEX   version;

//      short i;
        switch(msg) {
                case WM_INITDIALOG:
                        // cache the model pointer
                        dx=(Dialex*)lParam;
                        m=(Model*)dx->getDialogProject();

                        // set up the Tint pulldown box
                        m->buildTintComboBox(hwnd,CB_TINT);

                        // set up the check box for 3 states
                        SendDlgItemMessage(hwnd,CB_LOCKL,BM_SETSTYLE,BS_3STATE,TRUE);

                        dx->initializeDialogData(hwnd);

                        return TRUE;

                case WM_COMMAND:
                        switch(LOWORD(wParam)) {
                                case IDOK:
                                        dx->returnDialogData(hwnd);
                                case IDCANCEL:
                                        EndDialog(hwnd,LOWORD(wParam));
                                return TRUE;
                                case IDRETRY:
                                        dx->initializeDialogData(hwnd);
                                return TRUE;
                        }
                        return TRUE;
        }
        return 0;
}

BOOL _stdcall InputMatrixDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
        static Dialex *dx;

        short i;
        switch(msg) {
                case WM_INITDIALOG:
                        dx=(Dialex*)lParam;
                        dx->initializeDialogData(hwnd);
                return TRUE;
                case WM_CLOSE:
                        EndDialog(hwnd,0);
                        return 1;
                case WM_COMMAND:
                        switch (LOWORD(wParam)) {
                                case BB_PLAIN:
                                        for(i=0;i<12;i++)
                                        SetDlgItemFloat(hwnd,m_id[i],IDENTITY[i]);
                                return TRUE;
                                case IDRETRY:
                                        dx->initializeDialogData(hwnd);
                                return TRUE;
                                case IDOK:
                                        dx->returnDialogData(hwnd);
                                case IDCANCEL:
                                        EndDialog(hwnd,LOWORD(wParam));
                                return 1;
                        }
                break;
        }
        return 0;
}

BOOL _stdcall LatheDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
        static Dialex *dx;
        LPNMUPDOWN lpud;
        int pos;

        switch(msg) {
                case WM_NOTIFY:
                        lpud=(LPNMUPDOWN)lParam;
                        pos=GetDlgItemInt(hwnd,EB_VECX,NULL,FALSE)+lpud->iDelta;
                        if(pos<3) pos=3;
                        if(pos>120) pos=120;
                        SetDlgItemInt(hwnd,EB_VECX,pos,FALSE);
                        return 0;
                case WM_INITDIALOG:
                        dx=(Dialex*)lParam;
                        dx->initializeDialogData(hwnd);
                        SendDlgItemMessage(hwnd,UD_UPDOWN,UDM_SETPOS,(WPARAM)0,(LPARAM)GetDlgItemInt(hwnd,EB_VECX,NULL,FALSE));
                        SendDlgItemMessage(hwnd,UD_UPDOWN,UDM_SETRANGE,(WPARAM)0,(LPARAM)MAKELONG(120,3));
                        SendDlgItemMessage(hwnd,UD_UPDOWN,UDM_SETBUDDY,(WPARAM)(HWND)GetDlgItem(hwnd,EB_VECX),(LPARAM)0);
                        return TRUE;
                case WM_CLOSE:
                        EndDialog(hwnd,IDCANCEL);
                        return 1;
                case WM_COMMAND:
                        switch (LOWORD(wParam)) {
                                case IDOK:
                                        pos=GetDlgItemInt(hwnd,EB_VECX,NULL,FALSE);
                                        if(pos<3 || pos>120) {
                                                UserInt::informUser("Division count must be no less than 3 and no greater than 120.");
                                                SetForegroundWindow(hwnd);
                                                return 1;
                                        }
                                        dx->returnDialogData(hwnd);
                                case IDCANCEL:
                                        EndDialog(hwnd,LOWORD(wParam));
                                        return IDOK;
                        }
                        break;
        }
        return 0;
}

// selects tint in the tint window

void SetTintDialogControls(HWND hwnd,Tint* t,bool isUserTint) {
        SetDlgItemText(hwnd,EB_NAME,t->data.Name.c_string());
        SetDlgItemText(hwnd,EB_FILE,t->data.File.c_string());

        EnableWindow(GetDlgItem(hwnd,EB_NAME),isUserTint);
        EnableWindow(GetDlgItem(hwnd,EB_FILE),FALSE);
        EnableWindow(GetDlgItem(hwnd,BB_DELETE),isUserTint);
        EnableWindow(GetDlgItem(hwnd,BB_CHANGE),isUserTint);
        EnableWindow(GetDlgItem(hwnd,BB_SELECT),isUserTint);
}

void SelectComboBoxObject(HWND hwnd,int id,char *s) {
        int i;

//      if(s==NULL) return;

        i=(int)SendDlgItemMessage(hwnd,id,CB_FINDSTRINGEXACT,(WPARAM)-1,(LPARAM)s);
        SendDlgItemMessage(hwnd,id,CB_SETCURSEL,(WPARAM)i,(LPARAM)0);
}

BOOL _stdcall PickTintDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
    static Dialex *dx;
    static Tint *t;
    static  Model*  m;
    int i;
    char nameBuffer[256];

    switch(msg) {
        case WM_INITDIALOG:
            dx=(Dialex*)lParam;
            m=(Model*)dx->getDialogProject();

// add all existing tints to the dialog box
            m->buildTintComboBox(hwnd,CB_TINT);

            t=(Tint*)dx->getDialogObject(0);
            if(t==NULL) t=&(AppData::defTint);
// select the tint that is attached to the highlighted face
            SelectComboBoxObject(hwnd,CB_TINT,t->data.Name.c_string());
            SetTintDialogControls(hwnd,t,t!=&AppData::defTint);
            return TRUE;
        case WM_DRAWITEM:
            t->tintWindow(GetDlgItem(hwnd,IMG_IMAGEBOX));
            FillWindow(GetDlgItem(hwnd,IMG_COLORBOX),t->data.color);
            return TRUE;
        case WM_CLOSE:
            EndDialog(hwnd,0);
            return TRUE;
        case WM_COMMAND:
            switch (LOWORD(wParam)) {
                case CB_TINT:
                    switch(HIWORD(wParam)){
                        case CBN_SELCHANGE:
                            i=(int)SendDlgItemMessage(hwnd,CB_TINT,CB_GETCURSEL,(WPARAM)-1,0);
                            t=(Tint *)SendDlgItemMessage(hwnd,CB_TINT,CB_GETITEMDATA,i,0);
                            SetTintDialogControls(hwnd,t,t!=&AppData::defTint);
                            InvalidateRect(hwnd,NULL,FALSE);
                            InvalidateView();
                            break;
                    }
                    return TRUE;
                case BB_ADD:
                    t=m->newTint(0x808080);

                    i=(int)SendDlgItemMessage(hwnd,CB_TINT,CB_ADDSTRING,0,
                        (LPARAM)t->data.Name.c_string());
                    SendDlgItemMessage(hwnd,CB_TINT,CB_SETITEMDATA,(WPARAM)i,(LPARAM)t);

                    //highlight selection of added item
                    SelectComboBoxObject(hwnd,CB_TINT,t->data.Name.c_string());
                    SetTintDialogControls(hwnd,t,t!=&AppData::defTint);
                    t->hbm=(HBITMAP)0;
                    t->bmBits=(GLubyte *)0;
                    InvalidateRect(hwnd,NULL,FALSE);
                    return TRUE;
                case BB_CHANGE:
                    cc.hwndOwner=hwnd;
                    cc.Flags|=CC_RGBINIT;
                    cc.rgbResult=t->data.color;
                    if(ChooseColor(&cc)) {
                        t->data.color=cc.rgbResult;
                        t->deleteInfo();
//                      if(t->hbm) {
//                          DeleteObject(t->hbm);
//                          t->hbm=NULL;
//                          t->bmBits=NULL;
//                      }
                    }
                    InvalidateRect(hwnd,NULL,FALSE);
                    InvalidateView();
                    return 1;
                case BB_DELETE:
                    i=(int)SendDlgItemMessage(hwnd,CB_TINT,CB_GETCURSEL,0,0);
                    if(i==CB_ERR) return TRUE; // if no item selected, no item to delete
                    t=(Tint*)SendDlgItemMessage(hwnd,CB_TINT,CB_GETITEMDATA,i,0);
//                  if(t==&m->defTint) {
//                      MessageBoxEx(hwnd,"Cannot delete the default texture.","No!",MB_OK,LANG_NEUTRAL);
//                      return TRUE;
//                  }
                    if(MessageBoxEx(hwnd,"This will remove this texture from every face that has it applied.  Continue?",
                        "Warning",MB_OKCANCEL|MB_ICONWARNING,LANG_NEUTRAL)==IDOK) {
                        m->deleteTint(t);
                        SendDlgItemMessage(hwnd,CB_TINT,CB_DELETESTRING,i,0);
                        t=&AppData::defTint;
                        SelectComboBoxObject(hwnd,CB_TINT,t->data.Name.c_string());
                        SetTintDialogControls(hwnd,t,t!=&AppData::defTint);
                        t->tintWindow(GetDlgItem(hwnd,IMG_IMAGEBOX));
                    }
                    InvalidateRect(hwnd,NULL,FALSE);
                    InvalidateView();
                    return TRUE;
                case BB_SELECT:
                    GetGraphicFileName(hwnd,EB_FILE);
                    GetDlgItemText(hwnd,EB_FILE,nameBuffer,256);
                    if(strlen(nameBuffer)) {
                        t->data.File.copy(nameBuffer);
                    } else {
                        t->data.File.copy("");
                    }
                    t->deleteInfo();
//                    if(t->hbm) {
//                        DeleteObject(t->hbm);
//                        t->hbm=NULL;
//                        t->bmBits=NULL;
//                    }
                    t->deriveSolid();
                    SetTintDialogControls(hwnd,t,t!=&AppData::defTint);
                    InvalidateRect(hwnd,NULL,FALSE);
                    InvalidateView();
                    return TRUE;
                case IDOK:
                    i=(int)SendDlgItemMessage(hwnd,CB_TINT,CB_GETCURSEL,0,0);
                    if(i!=CB_ERR) {
                        t=(Tint*)SendDlgItemMessage(hwnd,CB_TINT,CB_GETITEMDATA,i,0);
                        dx->setDialogObject(0,t);
                    }
//                    MessageBoxEx(hwnd,"Here.","Status check",MB_OK,LANG_NEUTRAL);
                case IDCANCEL:
                    EndDialog(hwnd,LOWORD(wParam));
                    InvalidateView();
                    return TRUE;
                case EB_NAME:
                    if(HIWORD(wParam)==EN_KILLFOCUS) {
                        GetDlgItemText(hwnd,EB_NAME,nameBuffer,32);
                        if(strlen(nameBuffer)==0) {
                            MessageBoxEx(hwnd,"Textures need to be named.","Rejected",MB_OK,LANG_NEUTRAL);
                            SetFocus(GetDlgItem(hwnd,EB_NAME));
                            return TRUE;
                        }
                        if(m->isUniqueTintName(nameBuffer,t)==false) {
                            MessageBoxEx(hwnd,"Already another texture with that name.","Rejected",MB_OK,LANG_NEUTRAL);
                            SetFocus(GetDlgItem(hwnd,EB_NAME));
                            return TRUE;
                        }
                        t->data.Name.copy(nameBuffer);
                        i=(int)SendDlgItemMessage(hwnd,CB_TINT,CB_GETCURSEL,0,0);
                        SendDlgItemMessage(hwnd,CB_TINT,CB_DELETESTRING,i,0);
                        SendDlgItemMessage(hwnd,CB_TINT,CB_INSERTSTRING,i,(LPARAM)nameBuffer);
                        SendDlgItemMessage(hwnd,CB_TINT,CB_SETITEMDATA,i,(LPARAM)t);
                        InvalidateView();
                    }
                    return TRUE;
            }
            break;
        }
    return 0;
}

BOOL _stdcall CreateModelDlg(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
        static Dialex *dx;
//      static  Model*  m;
//        char*   name;
//        int i;
//        char nameBuffer[256];

        switch(msg) {
                case WM_INITDIALOG:
                        dx=(Dialex*)lParam;
                        dx->initializeDialogData(hwnd);
                return TRUE;
                case WM_CLOSE:
                        EndDialog(hwnd,0);
                return TRUE;
                case WM_COMMAND:
                        switch (LOWORD(wParam)) {
                                case BB_SELECT:
                                        GetMeshFileName(hwnd,EB_MESHFILE);
                                return TRUE;
                                case BB_SELECT2:
                                        GetTextureFileName(hwnd,EB_TEXTUREFILE);
                                return TRUE;
//                              case BB_SELECT3:
//                                      GetSkeletonFileName(hwnd,EB_SKELETONFILE);
//                              return TRUE;
                                case IDOK:
                                        dx->returnDialogData(hwnd);
                                case IDCANCEL:
                                        EndDialog(hwnd,LOWORD(wParam));
                                        InvalidateView();
                                return TRUE;
//                              case EB_NAME:
//                                      if(HIWORD(wParam)==EN_KILLFOCUS) {
//                                              GetDlgItemText(hwnd,EB_NAME,nameBuffer,32);
//                                      }
//                                return TRUE;
                        }
                break;
        }
        return 0;
}
