#ifndef EDGE_H
#define EDGE_H

//#include <windows.h>
#include "link.h"
#include "list.h"
#include "pointer.h"
//#include "wsum.h"

struct EdgeData {
    Ref<class Vert>   VertS;
    Ref<class Vert>   VertE;
    EdgeData();
    float   sharpLevel;
};

class EdgeEntry : public Entry {
    public:
        EdgeData    data;
};

//class Patch;

class Edge : public Thing {
    protected:
        Vec3    subLevel1;
        Vec3    subLevelf;
    public:
    EdgeData   data;
    eList  history;
    Ref<class Face> FaceL;
    Ref<class Face> FaceR;
    Ref<class UVPt> MapL;
    Ref<class UVPt> MapR;
    Ref<class Patch>    patchSL;
    Ref<class Patch>    patchSR;
    Ref<class Patch>    patchEL;
    Ref<class Patch>    patchER;

    Edge();
    ~Edge();
    void    draw(int);  // draws the edge
    void    trace(int); // traces the shape of the edge
    bool    checkWindings();
    float   getSharpLevel() { return data.sharpLevel; }
    Vert*   otherEnd(Vert*);
    void    replaceFace(Face*,Face*);
    void    setSharpLevel(const float newlevel) { data.sharpLevel=newlevel; }
    short   sharpType();
//    short   sharpType2();
    void    writeToFile(class fWriter&);

// subdivision preview stuff
//    void    prepSub();
//    void    weightSub1(Vec3& v,float w=1.0f) { subLevel1.add(v,w); }
//    void    weightSub2(Vec3& v,float w=1.0f) { subLevel2.add(v,w); }
//    void    weightSubS(Vec3& v,float w=1.0f) { subChildS.add(v,w); }
//    void    weightSubE(Vec3& v,float w=1.0f) { subChildE.add(v,w); }
    void    calcSub1();
    void    calcSubf();
//    void    calcSub2() { subLevel2.recalc(); }
//    void    calcSubS() { subChildS.recalc(); }
//    void    calcSubE() { subChildE.recalc(); }
//    Vec3&   getSubE() { return subChildE.result(); }
//    Vec3&   getSubS() { return subChildS.result(); }
    Vec3&   getSub1() { return subLevel1; }
    Vec3&   getSubf() { return subLevelf; }
//    Vec3&   getSub2() { return subLevel2.result(); }

    friend class Patch;

// undo/redo
    void    clipHistory(INDEX);
    bool    takeSnap(INDEX);
    void    restoreVersion(INDEX);
    void    destroyHistory();
};

// these flags are used in Edge.flags
//#define       TF_MARKED       1       // marked by the user for some reason
//#define       TF_DRAGGED      2       // needs to be redrawn with mouse move
//#define       TF_NEW          4       // created in current operation
//#define       TF_INVALID      8       // not valid due to delete/redo/undo operation
//#define       TF_KILLME   16  // to be destroyed during next sweep
//#define       TF_HIDDEN   32  // don't display this
#define EF_NO_LEFT      256
#define EF_NO_RIGHT     512
#define EF_BORDERMASK   768

#endif
