#ifndef FUNCS_H
#define FUNCS_H

//dialogs.c -- 14 global functions, none use significant globals
BOOL _stdcall AboutDlg(HWND,UINT,WPARAM,LPARAM);
BOOL _stdcall CreateModelDlg(HWND,UINT,WPARAM,LPARAM);
BOOL _stdcall EditBoneDlg(HWND,UINT,WPARAM,LPARAM);
//BOOL _stdcall EditEdgeDlg(HWND,UINT,WPARAM,LPARAM);
BOOL _stdcall EditFaceDlg(HWND,UINT,WPARAM,LPARAM);
BOOL _stdcall EditVertDlg(HWND,UINT,WPARAM,LPARAM);
BOOL _stdcall InputMatrixDlg(HWND,UINT,WPARAM,LPARAM);
BOOL _stdcall LatheDlg(HWND,UINT,WPARAM,LPARAM);
BOOL _stdcall PickTintDlg(HWND,UINT,WPARAM,LPARAM);
BOOL _stdcall InputStringDlg(HWND,UINT,WPARAM,LPARAM);
BOOL _stdcall PropDlg(HWND,UINT,WPARAM,LPARAM);
BOOL _stdcall ReparentDlg(HWND,UINT,WPARAM,LPARAM);
float GetDlgItemFloat(HWND,int);
void SelectComboBoxObject(HWND,int,char*);
void SetDlgItemFloat(HWND,int,float);

//display.c -- 7 global functions
// the following use neither LSM objects nor global variables
void SelectCombinedColor(COLORREF,COLORREF);
void SelectGLColor(COLORREF);
void SelectGLColorAlpha(COLORREF,float);
void InvalidateView(void);
void RightRect(RECT*);
void DrawMappedQuad(struct Vec2&,struct Vec3&,struct Vec2&,struct Vec3&,
    struct Vec2&,struct Vec3&,struct Vec2&,struct Vec3&,COLORREF,
    bool calc_norm=false);
void DrawQuad(struct Vec3&,struct Vec3&,struct Vec3&,struct Vec3&,COLORREF,
    bool calc_norm=false);

//files.c -- 7 global functions
void GetGraphicFileName(HWND,int);
void GetMeshFileName(HWND,int);
//void GetSkeletonFileName(HWND,int);
void GetTextureFileName(HWND,int);
void ImportProject(void);
void OpenFromCommandLine(LPSTR);
void OpenProject(void);

// lsm_file.c -- 1 global functions
long SkipBlock(HANDLE);

// opengl.c -- 4 global functions
void buildOpenGLLists();
HGLRC PrepareRenderingContext(HDC);
void OpenGLError(void);
void drawDart(void);

// string.cpp -- 7 global functions
// remaining functions do not employ global variables
void ScrubString(char *,char,char,char *);
char *CloneString(char *);
char *ConcatStrings(char*,char *);
void CopyString(char *,char *);
void FatFarm(char *);
void replaceExtension(char*,char*);
int strCmp(char*,char*); // like strcmp(), but accepts NULL pointers as
                         // input without crashing.

//toolbar.c -- 1 global function
HWND CreateAToolBar(HWND,HINSTANCE);

// 179 global functions as of 3 Dec 2005
// 164 global functions as of 4 Dec 2005
// 143 global functions as of 5 Dec 2005
// 105 global functions as of 6 Dec 2005
// 100 global functions as of 7 Dec 2005
//  95 global functions as of 11 Dec 2005
//  92 global functions as of 12 Dec 2005
//  91 global functions as of 27 Feb 2006
//  53 global functions as of 18 Jun 2007
//  51 global functions as of 13 Mar 2008

#endif // end of #ifdef FUNCS_H block
