// join.cpp -- implements the Join class

#include "join.h"
#include "uvpt.h"
#include "face.h"

Join::Join(UVPt* us,UVPt* ue)
    : UVPtS(us)
    , UVPtE(ue)
    , FaceL(0)
    , FaceR(0) {
    us->addJoin(this);
    ue->addJoin(this);
}

Join::~Join() {
    UVPtS->remJoin(this);
    UVPtE->remJoin(this);
    remove();
}

void Join::calcSub1() {
    (subLevel1=UVPtS->data.Spot)+=UVPtE->data.Spot;
    if(sharpType()) {
        subLevel1*=.5;
    } else {
        ((subLevel1+=FaceL->getUSub1())+=FaceR->getUSub1())*=.25;
    }
//    subLevelf.set(0);
}

void Join::calcSubf() {
    if(sharpType()) {
        ((((subLevelf=subLevel1)*=4.0f)+=UVPtS->getSub1())+=UVPtE->getSub1())*=.1666667f;
    } else {
        subLevelf*=.25;
    }
}

UVPt* Join::otherEnd(UVPt* ou) {
    if(ou==UVPtS) return UVPtE;
    return UVPtS;
}

int Join::sharpType() {
    if(FaceL==0) return -2;
    if(FaceL->data.uvpts==0) return -2;
    if(FaceR==0) return -2;
    if(FaceR->data.uvpts==0) return -2;
    return 0;
}
