// join.h -- declares the Join object

#ifndef JOIN_H
#define JOIN_H

#include "link.h"
#include "wsum.h"
#include "pointer.h"

class Join : public Link {
    protected:
        Vec2   subLevel1;
        Vec2   subLevelf; // for when the final level is calculated
    
    public:
        Join(class UVPt*,class UVPt*);
        ~Join();
        Ref<class UVPt> UVPtS;
        Ref<class UVPt> UVPtE;
        Ref<class Face> FaceL;
        Ref<class Face> FaceR;

    int sharpType();
    class UVPt* otherEnd(class UVPt*);

// subdivision preview stuff
//    void    prepSub();

//    void    weightSub2(Vec2& v,float w=1.0f) { subLevel2.add(v,w); }
//    void    weightSubS(Vec2& v,float w=1.0f) { subChildS.add(v,w); }
//    void    weightSubE(Vec2& v,float w=1.0f) { subChildE.add(v,w); }
    void    calcSub1();
    void    calcSubf();
//    void    calcSub2() { subLevel2.recalc(); }
//    void    calcSubS() { subChildS.recalc(); }
//    void    calcSubE() { subChildE.recalc(); }
    Vec2&   getSub1() { return subLevel1; }
    Vec2&   getSubf() { return subLevelf; }
//    Vec2&   getSub2() { return subLevel2.result(); }
//    Vec2&   getSubS() { return subChildS.result(); }
//    Vec2&   getSubE() { return subChildE.result(); }

    friend class Patch;
};

#endif

