// link.cpp -- implements the Link, Chain, Entry and Thing classes
#include "link.h"

Link::Link() {
        Next=(Link*)0;
        Prev=(Link*)0;
}

Thing::Thing() : flags(0)
{ }

Thing::~Thing() {
    remove();
}

Entry::~Entry() {
    remove();
}

Link *Link::next() {
    Link *n;
    
    n=Next;
    if(n->Next) return n; // if a link follows, this one is a valid link
    return 0;                           // otherwise, it's the rump
}

Link *Link::prev() {
    Link *p;

    p=Prev;
    if(p->Prev) return p; // if a link precedes, this one is a valid link
    return 0;                           // otherwise, it's the rump
}

void Link::remove() {
// links are only removed if they're actually linked in
        if(Next==(Link*)0) return;
        if(Prev==(Link*)0) return;

// point following link to preceding link
        Next->Prev=Prev;
// point preceding link to following link
        Prev->Next=Next;
//      l->Next=l->Prev=(link*)0;
}

Entry::Entry() : type(ET_NUL), version(0) { }
