#ifndef LINK_H
#define LINK_H

#include "lsmtypes.h"

class Link {
    public:
        Link *Next,*Prev;
        Link();
        Link *next();
        Link *prev();
        void remove();
        friend class List;
};

class Entry : public Link {
    public:
    INDEX   version;
    TYPE    type;
    Entry();
    ~Entry();
};

#define ET_NUL  0
#define ET_CHG  1
#define ET_DEL  2

class Thing : public Link {
    public:
    FLAGS   flags;  // for flagging
    INDEX   index;  // for indexing
    Thing();
    ~Thing();
};

#define TF_MARKED       1       // marked by the user for some reason
#define TF_DRAGGED      2       // needs to be redrawn with mouse move
#define TF_NEW          4       // created in current operation
#define TF_INVALID      8       // not valid due to delete/redo/undo operation
#define TF_KILLME   16  // to be destroyed during next sweep
#define TF_HIDDEN   32  // don't display this

#endif
