// lists.h -- template for the Chain template class

#ifndef CHAIN_H
#define CHAIN_H

#include "link.h"
#include "lsmtypes.h"

class List {
    private:
        Link    Head;
        Link    Tail;
    public:
        List();
        void addHead(Link*);
        void addTail(Link*);
        Link*   first();
        Link*   last();
};

// template for Lists of Entries
class eList : public List {
    public:
        void addHead(Entry* o) { List::addHead((Link*)o); }
        void addTail(Entry* o) { List::addTail((Link*)o); }
        Entry*  first() { return (Entry*) List::first(); }
        Entry*  last() { return (Entry*) List::last(); }
};

// template for Lists of Things
template<class T>
class tList : public List {
    public:
        void addHead(T* o) { List::addHead((Link*)o); }
        void addTail(T* o) { List::addTail((Link*)o); }
        T*  index(INDEX);
        T*  first() { return (T*) List::first(); }
        T*  last() { return (T*) List::last(); }
};

template<class T>
T* tList<T>::index(INDEX i) {
    T* t;

    for(t=first();t!=0;t=(T*)(t->Next))
    if(t->index==i) return t;
    return 0;
}

#endif

