#include <windows.h>
#include <stdio.h>
#include <gl/glu.h>
//#include <gl/glext.h>
#include <math.h>
#include "model.h"
#include "vert.h"
#include "edge.h"
#include "face.h"
#include "uvpt.h"
#include "bone.h"
#include "lsmres.h"
#include "pen.h"
#include "funcs.h"
#include "mouse.h"
#include "patch.h"
#include "appdata.h"

const extern COLORREF   PenColor[];

Model::Model()
        : NextBoneIndex(0)
        , NextEdgeIndex(0)
        , NextFaceIndex(0)
        , NextKnobIndex(0)
        , NextPartIndex(0)
        , NextTintIndex(0)
        , NextUVPtIndex(0)
        , NextVertIndex(0)
        , MeshSnap(.001f)
        , MapSnap(.001f)
        , LatheSteps(12)
        , modelFlags(MF_SHOW_PARTS|MF_SHOW_VERTS|MF_SHOW_EDGES|MF_SHOW_FACES)
        , patches(0)
        , subPreviewLevel(3)
{
        EditMode=EM_MESHEDIT;
        CurTint=&AppData::defTint;
        uView.Orient.setLVec(.5,.5,0.0);
        HighType=HT_NOTHING;
        HighItem.e=NULL;
        drag.e=(Edge*)0;
        anch.e=(Edge*)0;
        MarkType=HT_VERT;

        name.own(createModelName());
}

Model::~Model() {
        mergeDeleted();

        while(Faces.first()) nukeFace(FIRSTFACE(this));
        while(Joins.first()) nukeJoin(FIRSTJOIN(this));
        while(Norms.first()) nukeNorm(FIRSTNORM(this));
        while(Edges.first()) nukeEdge(FIRSTEDGE(this));
        while(Vertices.first()) nukeVertex(FIRSTVERT(this));
        while(Tints.first()) nukeTint(FIRSTTINT(this));
        while(UVPts.first()) nukeUVPt(FIRSTUVPT(this));
        while(Bones.first()) nukeBone(FIRSTBONE(this));
        while(patches) {
            Patch* p=patches->next;
            delete patches;
            patches=p;
        }
}

