// model_e.cpp -- implements member functions of class Model that start with 'e'

#include "userint.h"
#include <math.h>
#include "appdata.h"
#include "model.h"
#include "dialex.h"
#include "tint.h"
#include "face.h"
#include "vert.h"
#include "uvpt.h"
#include "bone.h"
#include "edge.h"
#include "funcs.h"
#include "lsmres.h"
#include "mouse.h"
#include "calc.h"

void Model::editHighTint(HWND hwnd) {
        MYPTR mp;
        Dialex *dx;

        if(HighType==HT_FACE) {
                mp.f=HighItem.f;
                dx=new Dialex;
                dx->setDialogObject(0,mp.f->data.Texture);
                dx->setDialogProject(this);
                if(DialogBoxParam(UserInt::hInst,MAKEINTRESOURCE(DLG_PICKTINT),hwnd,
                        PickTintDlg,(int)dx)==IDOK) {
                        mp.f->data.Texture = CurTint = (Tint*)dx->getDialogObject(0);
                }
                delete dx;
        }
//      ReportSystemError("Returned from PickTintDlg() safely.");
        takeSnap();
}

void Model::editHighProperties(HWND hwnd) {
//      short i;
        MYPTR m;
        Matrix qm;
        Dialex *dx;

        if(this==NULL) return;

        m.e=HighItem.e;

        switch(HighType) {
        case HT_EDGE:
                m.e=HighItem.e;
                dx=new Dialex;

                dx->setDialogFloat(EB_SHARP,m.e->getSharpLevel());
                if(DialogBoxParam(UserInt::hInst,MAKEINTRESOURCE(DLG_EDITEDGE),hwnd,
                    InputMatrixDlg,(LPARAM)dx)==IDOK) {
                    m.e->setSharpLevel(dx->getDialogFloat(EB_SHARP));
                    takeSnap();
                    modelFlags|=MF_BUILD_SUBD;
                }
                delete dx;
        break;
        case HT_FACE:
                m.f=HighItem.f;
                dx=new Dialex;

                dx->setDialogTint(CB_TINT,m.f->data.Texture);
                dx->setDialogProject(this);
                if(DialogBoxParam(UserInt::hInst,MAKEINTRESOURCE(DLG_EDITFACE),hwnd,
                        EditFaceDlg,(LPARAM)dx)==IDOK) {
                        m.f->data.Texture=dx->getDialogTint(CB_TINT);
                        takeSnap();
//                        modelFlags|=MF_RECALC_SUBD;
                }
                delete dx;
        break;
        case HT_VERT:
                m.v=HighItem.v;
                dx=new Dialex;

                dx->setDialogFloat(EB_ABSX,m.v->data.Spot.x);
                dx->setDialogFloat(EB_ABSY,m.v->data.Spot.y);
                dx->setDialogFloat(EB_ABSZ,m.v->data.Spot.z);
                dx->setDialogBone(CB_OWNER,m.v->data.Owner);
                dx->setDialogProject(this);
                if(DialogBoxParam(UserInt::hInst,MAKEINTRESOURCE(DLG_EDITVERT),hwnd,
                        EditVertDlg,(LPARAM)dx)==IDOK) {
                        m.v->data.Spot.x=dx->getDialogFloat(EB_ABSX);
                        m.v->data.Spot.y=dx->getDialogFloat(EB_ABSY);
                        m.v->data.Spot.z=dx->getDialogFloat(EB_ABSZ);
                        m.v->data.Owner=dx->getDialogBone(CB_OWNER);
                        takeSnap();
                        modelFlags|=MF_CALC_SUBD;
                }
                delete dx;
        break;
        case HT_UVPT:
                dx=new Dialex;
                dx->setDialogFloat(EB_VECX,m.u->data.Spot.u);
                dx->setDialogFloat(EB_VECY,m.u->data.Spot.v);
                if(DialogBoxParam(UserInt::hInst,MAKEINTRESOURCE(DLG_UVMAP),hwnd,InputMatrixDlg,(int)dx)==IDOK) {
                    m.u->data.Spot.u=dx->getDialogFloat(EB_VECX);
                    m.u->data.Spot.v=dx->getDialogFloat(EB_VECY);
                    takeSnap();
                    modelFlags|=MF_CALC_SUBD;
                }
                delete dx;
        break;
        case HT_BONE:
        case HT_KNOB:
                dx=new Dialex;
                dx->setDialogProject(this);
                dx->setDialogObject(0,m.b);
                dx->setDialogString(EB_NAME,m.b->data.Name.c_string());
                dx->setDialogFloat(EB_SCALEX,m.b->data.scale.x);
                dx->setDialogFloat(EB_SCALEY,m.b->data.scale.y);
                dx->setDialogFloat(EB_SCALEZ,m.b->data.scale.z);
                dx->setDialogFloat(EB_TWIST,m.b->data.twistAngle);
                dx->setDialogFloat(EB_BEND,m.b->data.bendAngle);
                dx->setDialogFloat(EB_TURN,m.b->data.turnAngle);
                dx->setDialogFloat(EB_ABSX,m.b->data.translate.x);
                dx->setDialogFloat(EB_ABSY,m.b->data.translate.y);
                dx->setDialogFloat(EB_ABSZ,m.b->data.translate.z);
//              dx->setDialogFlag(CB_LOCKL,m.b->data.flags&BF_LOCKED);
                if(m.b->data.Parent) {
                        dx->setDialogLabel(EB_PARENT,m.b->data.Parent->data.Name.c_string());
                } else {
                        dx->setDialogLabel(EB_PARENT,"-- not attached --");
                }
                if(DialogBoxParam(UserInt::hInst,MAKEINTRESOURCE(DLG_EDITBONE),hwnd,EditBoneDlg,(int)dx)==IDOK) {
                        m.b->data.scale.x=dx->getDialogFloat(EB_SCALEX);
                        m.b->data.scale.y=dx->getDialogFloat(EB_SCALEY);
                        m.b->data.scale.z=dx->getDialogFloat(EB_SCALEZ);
                        m.b->data.twistAngle=dx->getDialogFloat(EB_TWIST);
                        m.b->data.bendAngle=dx->getDialogFloat(EB_BEND);
                        m.b->data.turnAngle=dx->getDialogFloat(EB_TURN);
                        m.b->data.translate.x=dx->getDialogFloat(EB_ABSX);
                        m.b->data.translate.y=dx->getDialogFloat(EB_ABSY);
                        m.b->data.translate.z=dx->getDialogFloat(EB_ABSZ);
                        m.b->data.Name.own(dx->getDialogString(EB_NAME));
                        updateSkeleton(true);
                        takeSnap();
//                        modelFlags|=MF_CALC_SUBD;
                }
                delete dx;
        break;
        }
        InvalidateView();
}

void Model::editHighParent(HWND hwnd) {
//      short i;
        MYPTR m;
        Dialex *dx;

        if(this==NULL) return;

        m.e=HighItem.e;

        switch(HighType) {
        case HT_BONE:
        case HT_KNOB:
                dx=new Dialex;
                dx->setDialogProject(this);
                dx->setDialogObject(0,m.b);
                dx->setDialogBone(CB_OWNER,m.b->data.Parent);
                if(DialogBoxParam(UserInt::hInst,MAKEINTRESOURCE(DLG_REPARENT),hwnd,ReparentDlg,(int)dx)==IDOK) {
                        m.b->data.Parent=dx->getDialogBone(CB_OWNER);
                        m.b->reparent();
                        takeSnap();
                }
                delete dx;
        break;
        }
        InvalidateView();
}

void Model::editMarkedProperties(HWND hwnd) {
        Dialex* dx;

        switch(MarkType) {
                case HT_VERT:   {
                        Vert*   v;
                        bool first;
                        bool ax_good,ay_good,az_good;
                        bool b_good; Bone* b_use=0;
                        float ax,ay,az;
//                        int index;

                        b_good=
                        ax_good=ay_good=az_good=false;
                        first=true;

                        STEPVERTS(this,v)
                        if(v->flags&TF_MARKED)
                        if(first) {
                                b_good=
                                ax_good=ay_good=az_good=true;
                                first=false;
                                ax=v->data.Spot.x;
                                ay=v->data.Spot.y;
                                az=v->data.Spot.z;
                                b_use=v->data.Owner;
                        } else {
                                if(ax!=v->data.Spot.x) ax_good=false;
                                if(ay!=v->data.Spot.y) ay_good=false;
                                if(az!=v->data.Spot.z) az_good=false;
                                if(b_use!=v->data.Owner) b_good=false;
                        }

                        dx=new Dialex;
                        if(ax_good) { dx->setDialogFloat(EB_ABSX,ax); }
                                else { dx->setInvalidFloat(EB_ABSX); }
                        if(ay_good) { dx->setDialogFloat(EB_ABSY,ay); }
                                else { dx->setInvalidFloat(EB_ABSY); }
                        if(az_good) { dx->setDialogFloat(EB_ABSZ,az); }
                                else { dx->setInvalidFloat(EB_ABSZ); }
                        if(b_good) { dx->setDialogBone(CB_OWNER,b_use); }
                                else { dx->setInvalidBone(CB_OWNER); }

                        dx->setDialogProject(this);

                        if(DialogBoxParam(UserInt::hInst,MAKEINTRESOURCE(DLG_EDITVERT),hwnd,
                                EditVertDlg,(LPARAM)dx)==IDOK) {
// copy the stuff back to the marked verts
                                STEPVERTS(this,v)
                                if(v->flags&TF_MARKED) {
                                        if(dx->isValid(EB_ABSX))
                                                v->data.Spot.x=dx->getDialogFloat(EB_ABSX);
                                        if(dx->isValid(EB_ABSY))
                                                v->data.Spot.y=dx->getDialogFloat(EB_ABSY);
                                        if(dx->isValid(EB_ABSZ))
                                                v->data.Spot.z=dx->getDialogFloat(EB_ABSZ);
                                        if(dx->isValid(CB_OWNER))
                                                v->data.Owner=dx->getDialogBone(CB_OWNER);
                                }
                                takeSnap();
                                modelFlags|=MF_CALC_SUBD;
                        }
                        delete dx;
                } break;
                case HT_FACE:   {
                        Face*   f;
                        bool first;
                        bool t_good; Tint* t_use=0;
//                        int index;

                        t_good=false;
                        first=true;

                        STEPFACES(this,f)
                        if(f->flags&TF_MARKED)
                        if(first) {
                                t_good=true;
                                first=false;
                                t_use=f->data.Texture;
                        } else {
                                if(t_use!=f->data.Texture) t_good=false;
                        }

                        dx=new Dialex;
                        if(t_good) { dx->setDialogTint(CB_TINT,t_use); }
                                else { dx->setInvalidTint(CB_TINT); }

                        dx->setDialogProject(this);

                        if(DialogBoxParam(UserInt::hInst,MAKEINTRESOURCE(DLG_EDITFACE),hwnd,
                                EditFaceDlg,(LPARAM)dx)==IDOK) {
// copy the stuff back to the marked verts
                                STEPFACES(this,f)
                                if(f->flags&TF_MARKED) {
                                        if(dx->isValid(CB_TINT))
                                                f->data.Texture=dx->getDialogTint(CB_TINT);
                                }
                                takeSnap();
                        }
                        delete dx;
                } break;
        }
}

void Model::editMarkedTint(HWND hwnd) {
    Dialex *dx;
    MYPTR mp;

    dx=new Dialex;
    dx->setDialogObject(0,&AppData::defTint);
    dx->setDialogProject(this);
    if(DialogBoxParam(UserInt::hInst,MAKEINTRESOURCE(DLG_PICKTINT),hwnd,
        PickTintDlg,(int)dx)==IDOK) {

        CurTint=(Tint*)dx->getDialogObject(0);

        STEPFACES(this,mp.f)
        if(mp.f->flags&TF_MARKED)
        mp.f->data.Texture=CurTint;
    }
    delete dx;
    takeSnap();
}

void Model::enterMode(short newMode) {
        Face *f;
        UVPt *u;

        saveView();
        EditMode=newMode;

        switch(newMode) {
                case EM_MESHEDIT:
                        blankSelection();
                        cView=mView;
                break;
                case EM_MAPEDIT:
                        cView=uView;
                        cView.ViewUV();

                        STEPUVPTS(this,u)
                        u->flags&=~TF_NEW;

                        STEPFACES(this,f)
                        if(f->data.Texture==CurTint)
                        if(f->data.uvpts)
                        for(int i=0;i<f->data.sides;i++)
                        f->data.uvpts[i]->flags|=TF_NEW;
                break;
        }

        clearHighlight();
        clearAll();
        InvalidateView();
        setMouseMode(MM_NOTHING);
}

void Model::extrudeHigh() {
    Face* f=(Face*)0;
    if(HighType!=HT_FACE) return;

    f=HighItem.f;
    clearAll();

    f->flags|=TF_MARKED;

    MarkType=HT_FACE;
    applyMarkLogic();
    extrudeMarked();

    float a=f->calcArea();

    Vec3 norm;
    f->calcNormal(norm);
    norm.normalize();
    norm*=sqrtf(a);

    for(int i=0;i<f->data.sides;i++) f->data.verts[i]->data.Spot+=norm;

    gadget=new NormTransMeshGadget(this,f);
}

void Model::extrudeMarked() {
    Vert *v,*nv;
    Edge* e;
    Edge*   ne;
    Face *f,*nf /* ,*uf=(Face*)0 */;

    // clear all data from vertices that conflicts with extrusion
    STEPVERTS(this,v) {
        v->Copy=NULL;
        v->flags&=~TF_NEW;
    }

    // do the same with faces
    STEPFACES(this,f)
    f->flags&=~TF_NEW;

    // do a sanity check here--unmark all edges that have two unmarked faces bordering on them
    STEPEDGES(this,e)
    if(e->FaceL)
    if(e->FaceR)
    if(((e->FaceL->flags | e->FaceR->flags)&TF_MARKED)==0)
    e->flags&=~TF_MARKED;

    MarkType=HT_EDGE;
    applyMarkLogic();

    // edges are extruded if they are marked, and if they have exactly one
    // marked bordering face or if either bordering face is NULL
    STEPEDGES(this,e) {
        e->flags&=~TF_NEW;
        if(e->flags & TF_MARKED) {
            if(e->FaceL==NULL || e->FaceR==NULL) {
                e->flags|=TF_NEW;
            } else {
                if((e->FaceL->flags ^ e->FaceR->flags)&TF_MARKED) {
                    e->flags|=TF_NEW;
                }
            }
        }
    }

// both ends of the edges to be extruded are marked for copying
    STEPEDGES(this,e)
    if(e->flags & TF_NEW) {
        e->data.VertS->flags|=TF_NEW;
        e->data.VertE->flags|=TF_NEW;
    }

// all right, let's copy some vertices
    STEPVERTS(this,v)
    if(v->flags & TF_NEW) {
        v->Copy=nv=newVert(0,0);
        nv->data.Spot=v->data.Spot;
    }

// unmarked faces stay put, which means that unmarked faces use copied vertices, which stay put
    STEPFACES(this,f) {
        if((f->flags & TF_MARKED)==0) {
            for(int i=0;i<=f->data.sides;i++) {
                nv=f->data.verts[i]->Copy;
                if(nv) f->data.verts[i]=nv;
            }
        }// else {
//            uf=f; // there is at least one extruded face
//        }
    }

// unmarked edges stay put, which means that they use copied vertices, which stay put
    STEPEDGES(this,e)
    if((e->flags & TF_MARKED)==0) {
        nv=e->data.VertS->Copy;
        if(nv) {
            e->data.VertS->remEdge(e);
            e->data.VertS=nv;
            nv->addEdge(e);
        }
        nv=e->data.VertE->Copy;
        if(nv) {
            e->data.VertE->remEdge(e);
            e->data.VertE=nv;
            nv->addEdge(e);
        }
    }

    STEPVERTS(this,v)
    if(v->Copy)
    newEdge(v,v->Copy);

// remove the face references from the edges tagged for extrusion
// so that a face can be created using the tagged edge
// get the marked face pointer so that its texture can be applied to the
// face created for extrusion
    STEPEDGES(this,e)
    if(e->flags & TF_NEW) {
        ne=newEdge(e->data.VertS->Copy,e->data.VertE->Copy);

        if(e->FaceL)
        if(e->FaceL->flags&TF_MARKED) {
            f=e->FaceL;
        } else {
            e->FaceL->replaceEdge(e,ne);
            ne->FaceL=e->FaceL;
            e->FaceL=NULL;
        }

        if(e->FaceR)
        if(e->FaceR->flags&TF_MARKED) {
            f=e->FaceR;
        } else {
            e->FaceR->replaceEdge(e,ne);
            ne->FaceR=e->FaceR;
            e->FaceR=NULL;
        }

        if(ne->FaceL==NULL) {
            ne->FaceL=ne->FaceR;
            ne->FaceR=NULL;
        }

        nf=newFace(e->data.VertS,e->data.VertE,e->data.VertE->Copy,e->data.VertS->Copy);
        if(nf) {
//            nf->flags|=TF_NEW;   // mark faces created during operation
            if(f) nf->data.Texture=f->data.Texture;
        }
    }

    validate(); // get all faces using the right edges

    modelFlags|=MF_BUILD_SUBD;

    InvalidateView();
    takeSnap();

}

