// model_h.cpp -- implements class Model member functions starting with 'h'

#include "model.h"
#include "vert.h"
#include "edge.h"
#include "face.h"
#include "mouse.h"

void Model::hideHigh() {
    switch(HighType) {
        case HT_FACE:
            HighItem.f->flags|=TF_HIDDEN;
            break;
        case HT_EDGE:
            HighItem.e->flags|=TF_HIDDEN;
            break;
        case HT_VERT:
            HighItem.v->flags|=TF_HIDDEN;
            break;
    }
    HighItem.b=(Bone*)0;
    HighType=HT_NOTHING;
}

void Model::hideMarked() {
    Vert*   v;
    STEPVERTS(this,v)
    if(v->flags&TF_MARKED) {
        v->flags&=~TF_MARKED;
        v->flags|=TF_HIDDEN;
    }
    
    Edge*   e;
    STEPEDGES(this,e)
    if(e->flags&TF_MARKED) {
        e->flags&=~TF_MARKED;
        e->flags|=TF_HIDDEN;
    }

    Face*   f;
    STEPFACES(this,f)
    if(f->flags&TF_MARKED) {
        f->flags&=~TF_MARKED;
        f->flags|=TF_HIDDEN;
    }
}

void Model::hideUnmarked() {
    Vert*   v;
    STEPVERTS(this,v)
    if((v->flags&TF_MARKED)==0) {
        v->flags|=TF_HIDDEN;
    }
    
    Edge*   e;
    STEPEDGES(this,e)
    if((e->flags&TF_MARKED)==0) {
        e->flags|=TF_HIDDEN;
    }

    Face*   f;
    STEPFACES(this,f)
    if((f->flags&TF_MARKED)==0) {
        f->flags|=TF_HIDDEN;
    }
}



