// model_p.cpp -- implements member functions of class Model that start with 'p'

#include <windows.h>
#include <gl/glu.h>
//#include <gl/glext.h>
#include "model.h"
#include "bone.h"
#include "tint.h"
#include "vert.h"
#include "mouse.h"
#include "funcs.h"
#include "calc.h"

void Model::paintMapBackground() {
        Vec3 va,vb,vc,vd;
        Vec2 ta,tb,tc,td;

        lsmView *v=&cView;
        Tint* t=CurTint;

        v->mapScr2XYZ(0,0,va);
        v->mapScr2XYZ(v->sX,v->sY+32,vc);

        if(t->bmBits==NULL) t->getTintBitmap();
        t->selectIntoOpenGL();
        ta.u= tb.u= vb.x= va.x;
        tc.u= td.u= vd.x= vc.x;
        ta.v= td.v= vd.y= va.y;
        tb.v= tc.v= vb.y= vc.y;
        va.z=vb.z=vc.z=vd.z=1.0;

        glEnable(GL_TEXTURE_2D);
        DrawMappedQuad(ta,va,tb,vb,tc,vc,td,vd,0xffffff);
        glDisable(GL_TEXTURE_2D);
}

void Model::prepBoneDrag() {
        Bone*   b;

        STEPBONES(this,b) b->Save=b->Spot;

        finishVertDrag();
}

void Model::prepSingleVertDrag(Vert* v) {

        clearAllDragging();

        v->flags|=TF_DRAGGED;

        finishVertDrag();
}

void Model::prepVertDrag() {
        Vert* v;

        clearAllDragging();

        STEPVERTS(this,v)
        if(v->flags&TF_MARKED)
        v->flags|=TF_DRAGGED;

        finishVertDrag();
}

void Model::pushBackHigh() {
    if(HighItem.e==NULL) return;

    switch(HighType) {
        case HT_BONE:
        case HT_KNOB:
            HighItem.b->remove();
            Bones.addTail(HighItem.b);
            clearHighlight();
            break;
    }
}

