// model_t.cpp -- implements member functions of class Model that start with 't'

#include "userint.h"
#include "appdata.h"
#include "model.h"
#include "dialex.h"
#include "vert.h"
#include "edge.h"
#include "lsmres.h"
#include "lsmtypes.h"
#include "funcs.h"
#include "mouse.h"

void Model::toggleAll(void) {
        Vert* v;

        STEPVERTS(this,v)
        v->flags^=TF_MARKED;

        applyMarkLogic();
        InvalidateView();
}

void Model::toggleHighlight() {
        HighItem.e->flags^=TF_MARKED;
        MarkType=HighType;
        applyMarkLogic();
        InvalidateView();
}

void Model::translateMarked(HWND hwnd,short action) {
        Vert* v;
        Dialex *dx;

        dx=new Dialex;

        dx->setDialogLabel(0,"Translate by");
        dx->setDialogVector(EB_VECX,UserTranslate);

        if(DialogBoxParam(UserInt::hInst,MAKEINTRESOURCE(DLG_VECTOR),hwnd,
                InputMatrixDlg,(int)dx)==IDOK) {
                switch(action) {
                        case EA_EXTRUDE: extrudeMarked(); break;
                        case EA_COPY: copyMarked(); break;
                }
                STEPVERTS(this,v)
                if(v->flags&TF_MARKED) {
                    v->data.Spot+=UserTranslate;
                }
                InvalidateView();
        }

        modelFlags|=MF_CALC_SUBD;
        delete dx;
        takeSnap();
}

