// model_z.cpp -- implements Model member functions starting with 'z'

#include <windows.h>
#include "model.h"
#include "view.h"
#include "vert.h"
#include "uvpt.h"
#include "bone.h"
#include "edge.h"
#include "face.h"
#include "funcs.h"
#include "bound.h"

void Model::zoomToFit() {
    Bound   b;
    MYPTR m;
    Vec3 redux,center;
    Vec2    uredux;

    if(cView.sX<2 || cView.sY<2) return;

    switch(EditMode) {
        case EM_MESHEDIT:
            if(modelFlags&MF_SHOW_VERTS)
            STEPVERTS(this,m.v)
            if((m.v->flags&TF_HIDDEN)==0) {
                (redux=m.v->data.Spot)/=cView.Orient;
                b.include(redux);
            }

            if(modelFlags&MF_SHOW_PARTS)
            STEPBONES(this,m.b) {
                (redux=m.b->Spot)/=cView.Orient;
                b.include(redux);
            }

            if(modelFlags&MF_SHOW_EDGES)
            STEPEDGES(this,m.e)
            if((m.e->flags&TF_HIDDEN)==0) {
                (redux = m.e->data.VertS->data.Spot)/=cView.Orient;
                b.include(redux);
                (redux = m.e->data.VertE->data.Spot)/=cView.Orient;
                b.include(redux);
            }
            if(modelFlags&MF_SHOW_FACES)
            STEPFACES(this,m.f)
            if((m.f->flags&TF_HIDDEN)==0)
            for(int i=0;i<m.f->data.sides;i++) {
                (redux = m.f->data.verts[i]->data.Spot)/=cView.Orient;
                b.include(redux);
            }
        break;
        case EM_MAPEDIT:
            STEPUVPTS(this,m.u) {
                center.x=m.u->data.Spot.u;
                center.y=m.u->data.Spot.v;
                center.z=0.0;
                cView.Orient.invertUVector(center,uredux);
                b.include(uredux);
            }
            b.get_maxz()=b.get_minz()=0.0;
        break;
    }

    cView.zoomToBound(b);

    InvalidateView();
}

void Model::zoomToSelection() {
    Bound   b;
    MYPTR m;
    Vec3 redux /* ,center */;

    if(cView.sX<2 || cView.sY<2) return;

    switch(EditMode) {
        case EM_MESHEDIT:
            if(modelFlags&MF_SHOW_VERTS)
            STEPVERTS(this,m.v)
            if(m.v->flags&TF_MARKED) {
                (redux = m.v->data.Spot)/=cView.Orient;
                b.include(redux);
            }
            if(modelFlags&MF_SHOW_EDGES)
            STEPEDGES(this,m.e)
            if(m.e->flags&TF_MARKED) {
                (redux = m.e->data.VertS->data.Spot)/=cView.Orient;
                b.include(redux);
                (redux = m.e->data.VertE->data.Spot)/=cView.Orient;
                b.include(redux);
            }
            if(modelFlags&MF_SHOW_FACES)
            STEPFACES(this,m.f)
            if(m.f->flags&TF_MARKED)
            for(int i=0;i<m.f->data.sides;i++) {
                    (redux = m.f->data.verts[i]->data.Spot)/=cView.Orient;
                b.include(redux);
            }
        break;
//        case EM_MAPEDIT:
//            STEPUVPTS(this,m.u) {
//                center[X]=m.u->data.Spot[U];
//                center[Y]=m.u->data.Spot[V];
//                center[Z]=0.0;
//                cView.Orient.invertUVector(center,redux);
//                b.include(redux);
//            }
//            b.get_maxz()=b.get_minz()=0.0;
//        break;
    }

    cView.zoomToBound(b);
    InvalidateView();
}

