#include "userint.h"
#include <math.h>
#include "appdata.h"
#include "model.h"
#include "vert.h"
#include "edge.h"
#include "face.h"
#include "uvpt.h"
#include "bone.h"
#include "scene.h"
#include "funcs.h"
#include "mouse.h"
#include "calc.h"

RECT windRect,statRect;

Vec3 scr;
Vec3 xyz;

Vec3 tmp;

char buffer[20];

void Project::abortMode() {
    rightClick(UserInt::hwndMain,(WPARAM)0,(LPARAM)((lY<<16)|lX));
    rightRelease(UserInt::hwndMain,(WPARAM)0,(LPARAM)((lY<<16)|lX));
}

void Model::leftClick(HWND hwnd,WPARAM wParam,LPARAM lParam) {
    Bone*   b;
    int i;
    bool makeface;
    float dist;

    cX=lX=LOWORD(lParam);
    cY=lY=HIWORD(lParam);

    switch(EditMode|MouseMode) {
        case EM_MESHEDIT|MM_PANVIEW0:
        case EM_MAPEDIT|MM_PANVIEW0:
                setMouseMode(MM_PANVIEW1);
                sView.Orient=cView.Orient;
                SetCapture(UserInt::hwndMain);
        break;

        case EM_MESHEDIT|MM_ZOOMVIEW0:
        case EM_MAPEDIT|MM_ZOOMVIEW0:
                setMouseMode(MM_ZOOMVIEW1);
                sView.Scale=cView.Scale;
                SetCapture(UserInt::hwndMain);
        break;

        case EM_MESHEDIT|MM_ROTVIEW0:
                setMouseMode(MM_ROTVIEW1);
                sView.Orient=cView.Orient;
                SetCapture(UserInt::hwndMain);
        break;

        case EM_MESHEDIT|MM_ADDMESH0:
            if(HighType==HT_VERT) {
                anch.v=HighItem.v;
                dist=anch.v->data.Spot.dot(cView.Orient.z)
                    -cView.Orient.l.dot(cView.Orient.z);
                cView.Orient.l.x+=dist*cView.Orient.z.x;
                cView.Orient.l.y+=dist*cView.Orient.z.y;
                cView.Orient.l.z+=dist*cView.Orient.z.z;
            } else {
                anch.v=newVert(cX,cY);
            }
            InvalidateView();
            anch.v->Order=1;
            setMouseMode(MM_ADDMESH1);
        break;

        case EM_MESHEDIT|MM_ADDBONE:
            if(drag.b) defBone=drag.b;
            if(HighItem.b) {
                if(drag.b)
                if(drag.b->flags&TF_NEW) {
                    deleteBone(drag.b);
                }
                drag.b=HighItem.b;
                STEPBONES(this,b) b->flags&=~TF_NEW;
            } else {
                b=newBone(cX,cY);
//                (b->notScaled.fore.x=cView.Orient.z)*=-1.0;
                b->notScaled.fore.y=cView.Orient.y;
                b->notScaled.fore.z=cView.Orient.x;
                b->notScaled.fore.x.cross(b->notScaled.fore.y,b->notScaled.fore.z);
                b->notScaled.fore.l=b->Spot;
                b->notScaled.fore.invert(b->notScaled.back);
                b->Scaled=b->notScaled;
                b->data.Parent=defBone;
                b->reparent();
                b->flags|=TF_NEW;
                drag.b=b;
            }
            InvalidateView();
        break;

        case EM_MESHEDIT|MM_ADDVERT:
                newVert(cX,cY);
                InvalidateView();
        break;

        case EM_MESHEDIT|MM_ADDMESH1:
                setMouseMode(MM_ADDMESH0);
        break;

    case EM_MESHEDIT|MM_ADDMESH2:
        if(HighType==HT_VERT) {
            Edge* e;
            Face* f;
            dist=HighItem.v->data.Spot.dot(cView.Orient.z)
                -cView.Orient.l.dot(cView.Orient.z);
            cView.Orient.setLVec(
                cView.Orient.l.x+dist*cView.Orient.z.x,
                cView.Orient.l.y+dist*cView.Orient.z.y,
                cView.Orient.l.z+dist*cView.Orient.z.z
            );

            e=anch.v->findEdge(HighItem.v);
            if(e==NULL) {
                e=newEdge(anch.v,HighItem.v);
            }
            deleteVert(drag.v);
            drag.v=HighItem.v;
            switch(HighItem.v->Order) {
                case 0:
                    break;
                case 1:
                    blankSelection();
                    InvalidateView();
                    break;
                case 3:
                    decSelection();
                case 2:
                    decSelection();
                    break;
                default:
                    makeface=true;
                    for(i=2;i<HighItem.v->Order-1;i++) {
                        e=selectVert(i)->findEdge(selectVert(i+1));
                        if(e!=NULL)
                        if(e->FaceL!=NULL)
                        if(e->FaceR!=NULL)
                        makeface=false;
                    }
                    if(makeface) {
                        f=new Face;
                        Faces.addTail(f);
                        modelFlags|=MF_BUILD_SUBD;//|MF_REBUILD_NORMS;
                        // establish basic geometry
                        f->data.sides=HighItem.v->Order-1;
                        f->data.verts=new Vert*[f->data.sides+1];
                        for(i=0;i<f->data.sides;i++)
                        f->data.verts[i]=selectVert(i+2);

                        f->data.verts[f->data.sides]=selectVert(2);

                        // set other data to defaults
                        f->edges=new Edge*[f->data.sides];
                        f->data.Texture=CurTint;
                        f->index=NextFaceIndex++;

                        for(int i=0;i<f->data.sides;i++)
                        f->edges[i]=getEdge(f->data.verts[i],f->data.verts[i+1]);
                        validate();
                    }

                    blankSelection();
                    InvalidateView();
                    break;
            }
        }
        anch.v=drag.v;
        drag.v=NULL;
        anch.v->Order=1;
        setMouseMode(MM_ADDMESH1);
        ReleaseCapture();
        break;

        case EM_MESHEDIT|MM_NOTHING:
// if there's an active gadget, it "captures" the mouse clicks
            if(gadget) {
                short newmode=checkGadget();
                if(newmode!=MM_GADNULL)
                gadget->start(newmode,cX,cY);
                return;
            }
            switch(wParam) {
                case MK_LBUTTON:
                    clearAll();
                case MK_LBUTTON|MK_SHIFT:
                    checkHighlight(HT_VERT|HT_EDGE|HT_CLEAR|HT_BONE|HT_FACE);
                    switch(HighType) {
                        case HT_VERT:
                            HighItem.v->flags^=TF_MARKED;
                            MarkType=HT_VERT;
                            applyMarkLogic();
                            drag.v=HighItem.v;
                            prepSingleVertDrag(drag.v);
                            setMouseMode(MM_DRAGVERT);
                            SetCapture(UserInt::hwndMain);
//                            InvalidateView();
                            break;
                        case HT_EDGE:
                            HighItem.e->flags^=TF_MARKED;
                            MarkType=HT_EDGE;
                            applyMarkLogic();
                            break;
                        case HT_FACE:
                            HighItem.f->flags^=TF_MARKED;
                            MarkType=HT_FACE;
                            applyMarkLogic();
                            break;
                        case HT_BONE:
                            if(HighItem.b) {
                                gadget=new TransBoneGadget(this,HighItem.b);
                                gadget->start(MM_GADOVERK,cX,cY);
                                InvalidateView();
                            }
                            break;
                        case HT_KNOB:
                            if(HighItem.b) {
                                gadget=new RotBoneGadget(this,HighItem.b);
                                gadget->start(MM_GADOVERK,cX,cY);
                                InvalidateView();
                            }
                            break;
                        default:
                            setMouseMode(MM_LEFTDOWN);
                            SetCapture(UserInt::hwndMain);
                    }
                    break;
                case MK_CONTROL|MK_LBUTTON:
                    prepVertDrag();
                    SetCapture(hwnd);
                    setMouseMode(MM_DRAGVERT);
                    drag.v=NULL;
                    break;
            }
            break;
        case EM_MAPEDIT|MM_NOTHING:
            checkHighlight(HT_UVPT|HT_CLEAR);
            switch(HighType) {
                case HT_UVPT:
                    drag.u=HighItem.u;
                    InvalidateView();
                    drag.u->Save=drag.u->data.Spot;
                    setMouseMode(MM_DRAGVERT);
                    SetCapture(UserInt::hwndMain);
                    break;
            }
            break;
    }
}

void Model::leftDoubleClick(HWND hwnd,WPARAM /* wParam */, LPARAM /* lParam */ ) {
    switch(EditMode|MouseMode) {
        case EM_MESHEDIT|MM_NOTHING:
            checkHighlight(HT_VERT|HT_EDGE|HT_CLEAR);
            editHighProperties(hwnd);
        break;
        case EM_MAPEDIT|MM_NOTHING:
            checkHighlight(HT_UVPT|HT_CLEAR);
            editHighProperties(hwnd);
        break;
    }
}

void Model::rightClick(HWND /* hwnd */, WPARAM /* wParam */, LPARAM lParam) {
        MYPTR m;

        AppData::Popup=false;

        if(gadget) {
            takeSnap();
            gadget=0;
            setMouseMode(MM_NOTHING);
            clearHighlight();
            InvalidateView();
            return;
        }

        switch(MouseMode) {
            case MM_LEFTDOWN:
                return;
        }

        cX=lX=LOWORD(lParam);
        cY=lY=HIWORD(lParam);

        switch(EditMode|MouseMode) {
                case EM_MESHEDIT|MM_ADDBONE:
                    STEPBONES(this,m.b) m.b->flags&=~TF_NEW;
                    drag.b=(Bone*)0;
//                    updateSkeleton(true);
                case EM_MESHEDIT|MM_ADDVERT:
                case EM_MESHEDIT|MM_ADDMESH0:
                    InvalidateView();
                    takeSnap();
                case EM_MESHEDIT|MM_PANVIEW0:
                case EM_MAPEDIT|MM_PANVIEW0:
                case EM_MESHEDIT|MM_ZOOMVIEW0:
                case EM_MAPEDIT|MM_ZOOMVIEW0:
                case EM_MESHEDIT|MM_ROTVIEW0:
                    setMouseMode(MM_NOTHING);
                break;

                case EM_MESHEDIT|MM_ADDMESH1:
                case EM_MESHEDIT|MM_ADDMESH2:
                        deleteVert(drag.v);
                        drag.v=NULL;
//                        modelFlags|=MF_BUILD_SUBD;    // done in deleteVert()
                        ReleaseCapture();
                        anch.v=NULL;
                        setMouseMode(MM_ADDMESH0);
                        blankSelection();
                        InvalidateView();
                        takeSnap();
                break;

                case EM_MESHEDIT|MM_NOTHING:
                case EM_MAPEDIT|MM_NOTHING:
                    gadget=0;
                    setMouseMode(MM_RIGHTDOWN);
                break;
                case EM_MESHEDIT|MM_DRAGVERT:
                        STEPVERTS(this,m.v)
                        if(m.v->flags&TF_DRAGGED)
                        setMouseMode(MM_NOTHING);
                        ReleaseCapture();
                        takeSnap();
                break;
                case EM_MESHEDIT|MM_DRAGBONE:
                        ReleaseCapture();
                        drag.b=NULL;
//                        modelFlags|=MF_RECALC_SUBD;
                        setMouseMode(MM_NOTHING);
                        blankSelection();
                        InvalidateView();
                        takeSnap();
                break;
                case EM_MAPEDIT|MM_DRAGVERT:
                        takeSnap();
                        setMouseMode(MM_NOTHING);
                        drag.u=NULL;
                        ReleaseCapture();
                break;
        }
}

void Model::mouseMove(HWND hwnd,WPARAM /* wParam */,LPARAM lParam) {
    Vert* v;
    LONGFLAGS qf;
    float aX,aY,aR;
    float fC,fS;
    Matrix* rot;
    Vec2    uscr,uxyz;

    if(Project::activeProject==NULL) return;

    oX=lX;
    oY=lY;

    lX=LOWORD(lParam);
    lY=HIWORD(lParam);

    if(gadget)
    if(gadget->drag(lX,lY)) {
        InvalidateView();
        return;
    }

    switch(EditMode|MouseMode) {
        case EM_MAPEDIT|MM_LEFTDOWN:
        case EM_MESHEDIT|MM_LEFTDOWN:
                STEPVERTS(this,v)
                if(v->flags&TF_MARKED) {
                        v->flags|=TF_DRAGGED;
                } else {
                        v->flags&=~TF_DRAGGED;
                }
                setMouseMode(MM_LEFTBOX);
        break;
        case EM_MESHEDIT|MM_LEFTBOX:
                focusRect.top=cY;
                focusRect.left=cX;
                focusRect.right=lX;
                focusRect.bottom=lY;
                focusRectValid=true;
                if(cX!=lX && cY!=lY) {
                        windRect=focusRect;
                        RightRect(&windRect);
                        checkSelectBox(&windRect,HT_VERT);
                }
                InvalidateView();
        break;
        case EM_MAPEDIT|MM_NOTHING:
            checkHighlight(HT_UVPT);
        break;
        case EM_MESHEDIT|MM_NOTHING:
            if(gadget) {
                checkGadget();
            } else {
                checkHighlight(HT_VERT|HT_EDGE|HT_FACE|HT_BONE);
            }
        break;
        case EM_MAPEDIT|MM_ZOOMVIEW1:
        case EM_MESHEDIT|MM_ZOOMVIEW1:
                aR=(float)(cY-lY)/(float)cView.sM*2.0*LN10;
                fS=sView.Scale*expf(aR);
                if(fS<.0015) fS=.0015;
                if(fS>100000.0) fS=100000.0;
                cView.Scale=fS;
                if(gadget) gadget->rescale();
                InvalidateView();
        break;
        case EM_MESHEDIT|MM_PANVIEW1:
        case EM_MAPEDIT|MM_PANVIEW1:
                cView.mapScr2XYZ(cX,cY,xyz);
                cView.mapScr2XYZ(lX,lY,scr);

                cView.Orient.setLVec(sView.Orient.l.x+xyz.x-scr.x,
                        sView.Orient.l.y+xyz.y-scr.y,
                        sView.Orient.l.z+xyz.z-scr.z);
                InvalidateView();
        break;
        case EM_MESHEDIT|MM_ROTVIEW1:
                rot=new Matrix;

                aX=(float)(lX-cX);
                aY=(float)(cY-lY);
                aR=sqrtf((aX*aX+aY*aY));
                if(aR!=0.0) {
                        aX/=aR;
                        aY/=aR;
                }
                aR*=(PI/(float)cView.sM);
                fC=cosf(aR);
                fS=sinf(aR);

                rot->setXVec(aY*aY*(1.0-fC)+fC, -aX*aY*(1.0-fC),   -aX*fS);
                rot->setYVec(rot->x.y,       aX*aX*(1.0-fC)+fC, -aY*fS);
                rot->setZVec(-rot->x.z,      -rot->y.z,      fC);

                rot->mult(sView.Orient,cView.Orient);
                cView.Flags|=VF_NONPARALLEL;
                InvalidateView();

                delete rot;
        break;

// looking for vertices only, no active drag operation
        case EM_MESHEDIT|MM_ADDMESH0:
                checkHighlight(HT_VERT|HT_CLEAR);
        break;
// dragging one vertex, on the lookout for another
        case EM_MESHEDIT|MM_ADDMESH2:
// dragging a vertex, maybe looking for another
        case EM_MESHEDIT|MM_DRAGVERT:
                if(drag.v!=NULL) checkHighlight(HT_VERT|HT_CLEAR);
                cView.mapScr2XYZ(cX,cY,scr);
                cView.mapScr2XYZ(lX,lY,xyz);
                xyz-=scr;

                qf=modelFlags&MF_LOCK_MASK;

                switch(qf) {
                    case MF_LOCK_X:
                    case MF_LOCK_Y|MF_LOCK_Z:
                        scr.x=1.0f;scr.y=scr.z=0.0f;
                        break;
                    case MF_LOCK_Y:
                    case MF_LOCK_X|MF_LOCK_Z:
                        scr.y=1.0f;scr.x=scr.z=0.0f;
                        break;
                    case MF_LOCK_Z:
                    case MF_LOCK_X|MF_LOCK_Y:
                        scr.z=1.0f;scr.x=scr.y=0.0f;
                        break;
                }

                STEPVERTS(this,v)
                if(v->flags&TF_DRAGGED) {
                    (v->data.Spot=v->Save)+=xyz;

                    switch(qf) {
                        case MF_LOCK_X:
                        case MF_LOCK_Y:
                        case MF_LOCK_Z:
                            if(!tracePlane(v->Save,scr,v->data.Spot,cView.Orient.z,v->data.Spot)) {
                                switch(qf) {
                                    case MF_LOCK_X: v->data.Spot.x=v->Save.x; break;
                                    case MF_LOCK_Y: v->data.Spot.y=v->Save.y; break;
                                    case MF_LOCK_Z: v->data.Spot.z=v->Save.z; break;
                                }
                            }
                            break;
                        case MF_LOCK_Y|MF_LOCK_Z:
                        case MF_LOCK_X|MF_LOCK_Z:
                        case MF_LOCK_X|MF_LOCK_Y:
                            if(!nearest2Line(v->Save,scr,v->data.Spot,cView.Orient.z,v->data.Spot)) {
                                switch(qf) {
                                    case MF_LOCK_X|MF_LOCK_Z:
                                        v->data.Spot.x=v->Save.x;
                                        v->data.Spot.z=v->Save.z;
                                        break;
                                    case MF_LOCK_Y|MF_LOCK_X:
                                        v->data.Spot.x=v->Save.x;
                                        v->data.Spot.y=v->Save.y;
                                        break;
                                    case MF_LOCK_Y|MF_LOCK_Z:
                                        v->data.Spot.y=v->Save.y;
                                        v->data.Spot.z=v->Save.z;
                                        break;
                                }
                            }
                            break;
                    }
                    if(MeshSnap!=0.0)
                    v->snapToGrid(MeshSnap);
                }
                modelFlags|=MF_CALC_SUBD;
                InvalidateView();
        break;
// dragging a uv point, not looking for another
        case EM_MAPEDIT|MM_DRAGVERT:
                cView.mapScr2UV(cX,cY,uscr);
                cView.mapScr2UV(lX,lY,uxyz);
                uxyz.u-=uscr.u;
                uxyz.v-=uscr.v;

                drag.u->data.Spot.u=drag.u->Save.u+uxyz.u;
                drag.u->data.Spot.v=drag.u->Save.v+uxyz.v;
                if(MapSnap!=0.0)
                drag.u->snapUVPt(MapSnap);
                modelFlags|=MF_CALC_SUBD;
                InvalidateView();
        break;

        case EM_MESHEDIT|MM_DRAGBONE:
                cView.mapScr2XYZ(cX,cY,scr);
                cView.mapScr2XYZ(lX,lY,xyz);
                xyz-=scr;

                dragBone(drag.b,xyz);
                InvalidateView();
        break;
        case EM_MESHEDIT|MM_ADDBONE:
            if(drag.b)
            if(drag.b->flags&TF_NEW) {
                cView.mapScr2XYZ(cX,cY,scr);
                cView.mapScr2XYZ(lX,lY,xyz);
                xyz-=scr;
                if(xyz.normalize()>0.0f) {
                    drag.b->notScaled.fore.z=xyz;
                    drag.b->notScaled.fore.x.cross(cView.Orient.y,drag.b->notScaled.fore.z);
                    drag.b->notScaled.fore.x.normalize();
                    drag.b->notScaled.fore.y.cross(drag.b->notScaled.fore.z,drag.b->notScaled.fore.x);
                    drag.b->notScaled.fore.invert(drag.b->notScaled.back);
                    drag.b->Scaled=drag.b->notScaled;
                    drag.b->reparent();
                }
            }
            checkHighlight(HT_BONE|HT_CLEAR);
            InvalidateView();
        break;

        case EM_MESHEDIT|MM_ADDMESH1:
            incSelection();
            drag.v=newVert(lX,lY);
            drag.v->Order=1;
            newEdge(anch.v,drag.v);
            InvalidateView();
            prepSingleVertDrag(drag.v);
            setMouseMode(MM_ADDMESH2);
            SetCapture(hwnd);
        break;
    }
}

void Model::leftRelease(HWND hwnd,WPARAM /* wParam */,LPARAM lParam) {
        Vert* v;

        if(Project::activeProject==NULL) return;

        if(gadget)
        if(gadget->release()) {
            InvalidateView();
            return;
        }

        rX=lX=LOWORD(lParam);
        rY=lY=HIWORD(lParam);
        switch(EditMode|MouseMode) {
                case EM_MESHEDIT|MM_ROTVIEW1:
                case EM_MAPEDIT|MM_ROTVIEW1:
                        ReleaseCapture();
                        setMouseMode(MM_ROTVIEW0);
                break;

                case EM_MAPEDIT|MM_ZOOMVIEW1:
                case EM_MESHEDIT|MM_ZOOMVIEW1:
                        ReleaseCapture();
                        setMouseMode(MM_ZOOMVIEW0);
                break;

                case EM_MAPEDIT|MM_PANVIEW1:
                case EM_MESHEDIT|MM_PANVIEW1:
                        ReleaseCapture();
                        setMouseMode(MM_PANVIEW0);
                break;

                case EM_MESHEDIT|MM_LEFTDOWN:
                        setMouseMode(MM_NOTHING);
                        ReleaseCapture();
                break;
                case EM_MESHEDIT|MM_LEFTBOX:
                        setMouseMode(MM_NOTHING);
                        ReleaseCapture();
                        focusRectValid=false;
                        InvalidateView();
                break;
                case EM_MAPEDIT|MM_LEFTBOX:
                        setMouseMode(MM_NOTHING);
                        ReleaseCapture();
                        InvalidateView();
                break;
                case EM_MAPEDIT|MM_DRAGVERT:
                        takeSnap();
                        drag.u=NULL;
                        setMouseMode(MM_NOTHING);
                        ReleaseCapture();
                break;
                case EM_MESHEDIT|MM_DRAGVERT:
                    STEPVERTS(this,v) v->flags&=~TF_DRAGGED;
                    if(drag.v!=NULL)
                    if(HighType==HT_VERT) {
                        Vert *v,*hv;
                        v=drag.v;
                        hv=HighItem.v;
                        if(v!=hv)
                        if(MessageBoxEx(hwnd,"Merge vertices?","Decision time",MB_YESNO,0)!=IDNO) {
                            if(v==NULL) {
//                                UserInt::informUser("v==NULL");
                            } else {
                                mergeVerts(v,hv);
                            }
                        }
                    }
                    drag.v=NULL;
                    setMouseMode(MM_NOTHING);
                    ReleaseCapture();
//                        modelFlags|=MF_RECALC_SUBD;
                    takeSnap();
                break;
                case EM_MESHEDIT|MM_DRAGBONE:
                        setMouseMode(MM_NOTHING);
                        ReleaseCapture();
                        drag.b=NULL;
                        clearHighlight();
                        InvalidateView();
                        takeSnap();
                break;
        }
}

void Model::rightRelease(HWND /* hwnd */, WPARAM /* wParam */,LPARAM lParam) {

        if(Project::activeProject==NULL) return;

        rX=lX=LOWORD(lParam);
        rY=lY=HIWORD(lParam);
        switch(EditMode|MouseMode) {
                case EM_MESHEDIT|MM_RIGHTDOWN:
                        setMouseMode(MM_NOTHING);
                        checkHighlight(HT_CLEAR|HT_VERT|HT_EDGE|HT_BONE|HT_FACE);
                        AppData::Popup=true;
                        ReleaseCapture();
                break;
                case EM_MAPEDIT|MM_RIGHTDOWN:
                        setMouseMode(MM_NOTHING);
                        checkHighlight(HT_CLEAR|HT_UVPT);
                        AppData::Popup=true;
                        ReleaseCapture();
                break;
        }
}

void Project::clearHighlight() {
        HighType=HT_NOTHING;
        HighItem.v=NULL;
}

void Project::setMouseMode(int nm) {
        char *s;

//        char buff[20];

//        sprintf(buff,"Size of Link=%d",sizeof(Link));

        MouseMode=nm;

        s="";//buff;
        switch(nm) {
                case MM_NOTHING:        s="Select mode";        break;
                case MM_PANVIEW0:
                case MM_PANVIEW1:
                        s="Left-click and drag to drag the view";
                break;
                case MM_ZOOMVIEW0:
                case MM_ZOOMVIEW1:
                        s="Left-click and drag to zoom the view";
                break;
                case MM_ROTVIEW0:
                case MM_ROTVIEW1:
                        s="Left-click and drag to rotate the view";
                break;
                case MM_ADDMESH0:
                case MM_ADDMESH1:
                case MM_ADDMESH2:       s="Adding mesh data";   break;
                case MM_ADDVERT:    s="Click to add vertices";      break;
                case MM_ADDBONE:        s="Add bone";   break;
                case    MM_GADOVERX: s="Click here to drag along X axis"; break;
                case    MM_GADOVERY: s="Click here to drag along Y axis"; break;
                case    MM_GADOVERZ: s="Click here to drag along Z axis"; break;
        }
        UserInt::updateStatusBar(s,0,0);
        updateToolBar();
        updateMenu();
}

