// mystr.cpp -- implements the Mystr class

#include <string.h>
#include "mystr.h"

Mystr::Mystr() : data((char*)0) { }

Mystr::~Mystr() {
        if(data) delete []data;
//      data=(char*)0;
}

bool Mystr::operator==(char* s) {
        int i;

        if(data==(char*)0) {
                if (s==(char*)0) return true;    // both are null strings
                return false;    // this is null, other is not
        }

        if(s==(char*)0) return false;  // this is not null, other is

        for(i=0;data[i] && s[i];i++)
        if(data[i]!=s[i]) return false;

        return data[i]==s[i];
}

bool Mystr::operator==(Mystr& om) {
        return (*this == om.data);
}

bool Mystr::operator!=(Mystr& om) {
        return !(*this == om.data);
}

Mystr& Mystr::operator=(Mystr& om) {
        if(data) delete []data;

        int l=om.len();

        if(l==0) {
                data=(char*)0;
        } else {
                data=new char[l+1];
                for(int i=0;i<=l;i++)
                data[i]=om.data[i];
        }

        return *this;
}

void Mystr::copy(char* s) {
    if(data) delete []data;

    int l;

    if(s) {
        l=strlen(s);
    } else {
        l=0;
    }

    if(l==0) {
        data=(char*)0;
    } else {
        data=new char[l+1];
        for(int i=0;i<=l;i++)
        data[i]=s[i];
    }
}

int Mystr::len() {
        if (data) return strlen(data);

        return 0;
}

Mystr&  Mystr::operator+=(char* s) {
        char*   buff;

        if(s==(char*)0) return *this;

        int l=len()+strlen(s);

        buff=new char[l+1];

        int i,j;

        if(data)
        for(i=0;data[i];i++)
        buff[i]=data[i];

        for(j=0;s[j];j++)
        buff[i+j]=s[j];

        buff[i+j]='\0';

        if(data) delete []data;
        data=buff;

        return *this;
}

char Mystr::last() {
        if(data==0) return 0;

        return data[len()-1];
}

Mystr&  Mystr::operator+=(char s) {
        char*   buff;

        int l=len()+1;

        buff=new char[l+1];

        int i;

        i=0;
        if(data)
        for(i=0;data[i];i++)
        buff[i]=data[i];

        buff[i++]=s;

        buff[i++]='\0';

        if(data) delete []data;
        data=buff;

        return *this;
}

Mystr::Mystr(char* s) {
        if(s==(char*)0) {
                data=(char*)0;
                return;
        }

        int l=strlen(s);

        if(l==0) {
                data=(char*)0;
                return;
        }

        data=new char[l+1];

        for(int i=0;i<=l;i++)
        data[i]=s[i];
}

void Mystr::own(char* s) {
        if(data) delete []data;

        data=s;
}

bool Mystr::cut_from(const char c) {
        int l = len()-1;

        for(l=len()-1;l>=0;l--) {
                if(data[l]==c) {
                        data[l]='\0';
                        return true;
                }
        }
        return false;
}

void Mystr::reduceWhiteSpace() {
        int i,j;

        if(data==(char*)0) return;

        for(i=0;data[i];i++)
        if(data[i]=='\11'  // tab
                || data[i]=='\15'  //   CR
                || data[i]=='\12'  //  LF
        ) data[i]=' '; // replace all of the above with spaces

// strip leading spaces
        while(data[0]==' ')
        for(i=0;data[i];i++)
        data[i]=data[i+1];

// remove all spaces that are preceded by a comma or slash, or are followed by
// a space, comma, slash, or null character
        for(i=1;data[i];i++)   // the first character is never a space
        while(data[i]==' ' &&
                (data[i-1]==',' || data[i-1]=='/'
                || data[i+1]==' ' || data[i+1]==',' || data[i+1]=='/' || data[i+1]=='\0') )
        for(j=i;data[j];j++) // shift all succeeding characters left
        data[j]=data[j+1];
}
