// obvec.h -- template for the ObVec classes

#ifndef OBVEC_H
#define OBVEC_H

template<class T>
class ObVec {
    private:
        int count;
//        int ptr;
        T* objects;
    public:
        ObVec() : count(0), objects(0) { }
        ~ObVec();
        void clear();
        bool good();
        int find(T);
//        T  current();
        T&  operator[](int i) {
//            if(objects==0 || i<0 || i>=count) return (T)0;
            return objects[i];
        }
        int pop() { return count; }
        void    append(T);
        void    remove(T);
};

//template<class T>
//ObVec<T>::ObVec() : ptr(0),count(0),objects((T*)0) { }

template<class T>
ObVec<T>::~ObVec() { clear(); }

template<class T>
void ObVec<T>::clear() {
    count=0;
//    ptr=0;
    if(objects) delete []objects;
    objects=0;
}

template<class T>
bool ObVec<T>::good() {
    if (objects==0) return false;
//    if (ptr>=count) return false;
    return true;
}

template<class T>
int ObVec<T>::find(T o) {
    if(objects==0) return -1;
    for(int i=0;i<count;i++)
    if(objects[i]==o) return i;
    return -1;
}

//template<class T>
//T ObVec<T>::current() {
//    if(good()) return objects[ptr];
//    return (T)0;
//}

template<class T>
void ObVec<T>::append(T no) {
    T*  newlist;

    newlist=new T[count+1];
    if(newlist) {
        if(objects) {
            for(int i=0;i<count;i++) {
                newlist[i]=objects[i];
            }
            delete []objects;
        }
        objects=newlist;
        objects[count]=no;
        count++;
    }
}

template<class T>
void ObVec<T>::remove(T o) {
    if(objects==(T*)0) return;
    for(int i=0;i<count;i++)
    if(objects[i]==o) {
        objects[i]=objects[count-1];
        objects[count-1]=(T)0;
        count--;
    }
}

// This is used to track arrays that are owned by the object containing the array
// pointer.  It's main purpose is to ensure proper destruction of the array when
// passage out of scope.
// It's like the ObVec, but doesn't need to know how big it is, and therefore does
// not have insert, append, and delete functions.

template<class T>
class Array {
    protected:
        T*  data;
    public:
        Array() { data=(T*)0; }
        Array(int n) { data=new T[n]; }
        ~Array() { if(data) delete []data; }
        T& operator[](int i) { return data[i]; }
        operator bool() const { return data!=0; }
        T*  operator=(T* n) { if(data) delete []data; return (data=n); }   // set
        operator T*() const { return data; }
};

#endif

