#include "userint.h"
#include <gl/gl.h>
#include <gl/glu.h>
#include "funcs.h"
#include "calc.h"
#include "transform.h"
#include "opengl.h"
#include "appdata.h"

float ball[]= {
     1.0f,     0.0f,     0.0f,
     SQRT_1_2,-SQRT_1_2, 0.0f,
     SQRT_1_3,-SQRT_1_3,-SQRT_1_3,
     SQRT_1_2, 0.0f,    -SQRT_1_2,
     SQRT_1_3, SQRT_1_3,-SQRT_1_3,
     SQRT_1_2, SQRT_1_2, 0.0f,
     SQRT_1_3, SQRT_1_3, SQRT_1_3,
     SQRT_1_2, 0.0f,     SQRT_1_2,
     SQRT_1_3,-SQRT_1_3, SQRT_1_3,
     SQRT_1_2,-SQRT_1_2, 0.0f,

     0.0f,     0.0f,     1.0f,
    -SQRT_1_2, 0.0f,     SQRT_1_2,
    -SQRT_1_3,-SQRT_1_3, SQRT_1_3,
     0.0f,    -SQRT_1_2, SQRT_1_2,
     SQRT_1_3,-SQRT_1_3, SQRT_1_3,//= number 8
     SQRT_1_2, 0.0f,     SQRT_1_2,//= number 7
     SQRT_1_3, SQRT_1_3, SQRT_1_3,//= number 6
     0.0f,     SQRT_1_2, SQRT_1_2,
    -SQRT_1_3, SQRT_1_3, SQRT_1_3,
    -SQRT_1_2, 0.0f,     SQRT_1_2,

     0.0f,     1.0f,     0.0f,
     0.0f,     SQRT_1_2,-SQRT_1_2,
    -SQRT_1_3, SQRT_1_3,-SQRT_1_3,
    -SQRT_1_2, SQRT_1_2,  0,
    -SQRT_1_3, SQRT_1_3, SQRT_1_3, //= number 28
     0.0f,     SQRT_1_2, SQRT_1_2, //= number 27
     SQRT_1_3, SQRT_1_3, SQRT_1_3, //= number 6
     SQRT_1_2, SQRT_1_2, 0,        //= number 5
     SQRT_1_3, SQRT_1_3,-SQRT_1_3, //= number 4
     0.0f,     SQRT_1_2,-SQRT_1_2
};    

const GLfloat circ[65]={
 0.0f,    -1.0f,    0.0f,  0.0f,    -1.0f,
-BEZ_CIRC,-1.0f,    0.0f, -BEZ_CIRC,-1.0f,
-1.0f,    -BEZ_CIRC,0.0f, -1.0f,    -BEZ_CIRC,
-1.0f,     0.0f,    0.0f, -1.0f,     0.0f,
-1.0f,     BEZ_CIRC,0.0f, -1.0f,     BEZ_CIRC,
-BEZ_CIRC, 1.0f,    0.0f, -BEZ_CIRC, 1.0f,
 0.0f,     1.0f,    0.0f,  0.0f,     1.0f,
 BEZ_CIRC, 1.0f,    0.0f,  BEZ_CIRC, 1.0f,
 1.0f,     BEZ_CIRC,0.0f,  1.0f,     BEZ_CIRC,
 1.0f,     0.0f,    0.0f,  1.0f,     0.0f,
 1.0f,    -BEZ_CIRC,0.0f,  1.0f,    -BEZ_CIRC,
 BEZ_CIRC,-1.0f,    0.0f,  BEZ_CIRC,-1.0f,
 0.0f,    -1.0f,    0.0f,  0.0f,    -1.0f
};

const GLfloat flipxy[16]={
    0.0,    1.0,    0.0,    0.0,
    1.0,    0.0,    0.0,    0.0,
    0.0,    0.0,    1.0,    0.0,
    0.0,    0.0,    0.0,    1.0
};

const GLfloat flipxz[16]={
    0.0,    0.0,    1.0,    0.0,
    0.0,    1.0,    0.0,    0.0,
    1.0,    0.0,    0.0,    0.0,
    0.0,    0.0,    0.0,    1.0
};

const GLfloat flipyz[16]={
    1.0,    0.0,    0.0,    0.0,
    0.0,    0.0,    1.0,    0.0,
    0.0,    1.0,    0.0,    0.0,
    0.0,    0.0,    0.0,    1.0
};

const GLfloat Arrow[9][6]={
    {  1.00,0.00,0.00,-0.90,0.0,0.0 },
    { -1.00,-.05,0.00,-0.90,0.0,0.0 },
    { -1.00, .05,0.00,-0.90,0.0,0.0 },
    { -1.00,0.00,-.05,-0.90,0.0,0.0 },
    { -1.00,0.00, .05,-0.90,0.0,0.0 },
    {  0.90,-.05,0.00, 1.00,0.0,0.0 },
    {  0.90,0.05,0.00, 1.00,0.0,0.0 },
    {  0.90,0.00,-.05, 1.00,0.0,0.0 },
    {  0.90,0.00,0.05, 1.00,0.0,0.0 }
};

const GLfloat cube[24]= {
    -1.0f,-1.0f,-1.0f,
     1.0f,-1.0f,-1.0f,
    -1.0f, 1.0f,-1.0f,
     1.0f, 1.0f,-1.0f,
    -1.0f,-1.0f, 1.0f,
     1.0f,-1.0f, 1.0f,
    -1.0f, 1.0f, 1.0f,
     1.0f, 1.0f, 1.0f
};

void buildOpenGLLists() {
    glNewList(AppData::GLObjBase+AD_OBJ_CIRCLE,GL_COMPILE);
    glEnable(GL_MAP1_VERTEX_3);
    glMapGrid1f(32,0.0f,1.0f);
    glMap1f(GL_MAP1_VERTEX_3,0.0f,1.0f,5,4,circ);
    glEvalMesh1(GL_LINE,0,32);
    glMap1f(GL_MAP1_VERTEX_3,0.0f,1.0f,5,4,circ+15);
    glEvalMesh1(GL_LINE,0,32);
    glMap1f(GL_MAP1_VERTEX_3,0.0f,1.0f,5,4,circ+30);
    glEvalMesh1(GL_LINE,0,32);
    glMap1f(GL_MAP1_VERTEX_3,0.0f,1.0f,5,4,circ+45);
    glEvalMesh1(GL_LINE,0,32);
    glDisable(GL_MAP1_VERTEX_3);
    glEndList();

    glNewList(AppData::GLObjBase+AD_OBJ_FLIPXY,GL_COMPILE);
    glMultMatrixf(flipxy);
    glEndList();

    glNewList(AppData::GLObjBase+AD_OBJ_FLIPXZ,GL_COMPILE);
    glMultMatrixf(flipxz);
    glEndList();

    glNewList(AppData::GLObjBase+AD_OBJ_FLIPYZ,GL_COMPILE);
    glMultMatrixf(flipyz);
    glEndList();

    glNewList(AppData::GLObjBase+AD_OBJ_BALL,GL_COMPILE);
    glShadeModel(GL_SMOOTH);
    glEnableClientState(GL_VERTEX_ARRAY);
    glEnableClientState(GL_NORMAL_ARRAY);
    glVertexPointer(3,GL_FLOAT,0,ball);
    glNormalPointer(GL_FLOAT,0,ball);
    glEnable(GL_NORMALIZE);

    for(int i=0;i<2;i++) {
        glBegin(GL_TRIANGLE_FAN);
        glArrayElement(0);
        glArrayElement(1);
        glArrayElement(2);
        glArrayElement(3);
        glArrayElement(4);
        glArrayElement(5);
        glArrayElement(6);
        glArrayElement(7);
        glArrayElement(8);
        glArrayElement(9);
        glEnd();

        glBegin(GL_TRIANGLE_FAN);
        glArrayElement(10);
        glArrayElement(11);
        glArrayElement(12);
        glArrayElement(13);
        glArrayElement(14);
        glArrayElement(15);
        glArrayElement(16);
        glArrayElement(17);
        glArrayElement(18);
        glArrayElement(19);
        glEnd();

        glScalef(-1.0,1.0,-1.0);
    }

    for(int i=0;i<2;i++) {
        glBegin(GL_TRIANGLE_FAN);
        glArrayElement(20);
        glArrayElement(21);
        glArrayElement(22);
        glArrayElement(23);
        glArrayElement(24);
        glArrayElement(25);
        glArrayElement(26);
        glArrayElement(27);
        glArrayElement(28);
        glArrayElement(29);
        glEnd();

        glScalef(1.0,-1.0,-1.0);
    }

    glDisableClientState(GL_VERTEX_ARRAY);
    glDisableClientState(GL_NORMAL_ARRAY);
    glEndList();

    glNewList(AppData::GLObjBase+AD_OBJ_ARROW,GL_COMPILE);
    glBegin(GL_LINES);
    for(int i=0;i<9;i++) { glVertex3fv(Arrow[i]); glVertex3fv(Arrow[i]+3); }
    glEnd();
    glEndList();

    glNewList(AppData::GLObjBase+AD_OBJ_CHARX,GL_COMPILE);
    glVertex2f(-.1,  0.0); glVertex2f(-.05,0.0);
    glVertex2f(-.025,-.1); glVertex2f( .1,  .1);
    glVertex2f(-.025, .1); glVertex2f( .1, -.1);
    glEndList();

    glNewList(AppData::GLObjBase+AD_OBJ_CHARY,GL_COMPILE);
    glVertex2f(-.1,   0.0); glVertex2f(-.05,  0.0);
    glVertex2f(-.025,  .1); glVertex2f( .0375,0);
    glVertex2f( .1,    .1); glVertex2f( .0375,0.0);
    glVertex2f( .0375,-.1); glVertex2f( .0375,0.0);
    glEndList();

    glNewList(AppData::GLObjBase+AD_OBJ_CHARZ,GL_COMPILE);
    glVertex2f(-.1,  0.0); glVertex2f(-.05, 0.0);
    glVertex2f(-.025, .1); glVertex2f( .1,   .1);
    glVertex2f( .1,   .1); glVertex2f(-.025,-.1);
    glVertex2f(-.025,-.1); glVertex2f( .1,  -.1);
    glEndList();

    glNewList(AppData::GLObjBase+AD_OBJ_CUBE,GL_COMPILE);
    glBegin(GL_QUAD_STRIP);
    glVertex3fv(cube);   glVertex3fv(cube+12);
    glVertex3fv(cube+3); glVertex3fv(cube+15);
    glVertex3fv(cube+9); glVertex3fv(cube+21);
    glVertex3fv(cube+6); glVertex3fv(cube+18);
    glVertex3fv(cube);   glVertex3fv(cube+12);
    glEnd();
    glBegin(GL_QUADS);
    glVertex3fv(cube);
    glVertex3fv(cube+3);
    glVertex3fv(cube+9);
    glVertex3fv(cube+6);
    glVertex3fv(cube+12);
    glVertex3fv(cube+15);
    glVertex3fv(cube+21);
    glVertex3fv(cube+18);
    glEnd();
    glEndList();

    glNewList(AppData::GLObjBase+AD_OBJ_CONE,GL_COMPILE);
    glBegin(GL_TRIANGLE_FAN);
    glVertex3f(1, 0,        0);
    glVertex3f(0,-1,        0);
    glVertex3f(0,-SQRT_1_2,-SQRT_1_2);
    glVertex3f(0, 0,       -1);
    glVertex3f(0, SQRT_1_2,-SQRT_1_2);
    glVertex3f(0, 1,        0);
    glVertex3f(0, SQRT_1_2, SQRT_1_2);
    glVertex3f(0, 0,        1);
    glVertex3f(0,-SQRT_1_2, SQRT_1_2);
    glVertex3f(0,-1,        0);
    glEnd();
    glEndList();
}

HGLRC PrepareRenderingContext(HDC hdc) {
    HGLRC rc;
    HBITMAP hbr;
    PIXELFORMATDESCRIPTOR pfd;
    int pfi;
    BITMAP bi;

    static short flag1=0;

    hbr=(HBITMAP)GetCurrentObject(hdc,OBJ_BITMAP);
    GetObject(hbr,sizeof(BITMAP),&bi);

    memset(&pfd,0,sizeof(PIXELFORMATDESCRIPTOR));
    pfd.nSize=sizeof(PIXELFORMATDESCRIPTOR);
    pfd.nVersion=1;
    pfd.dwFlags=PFD_DRAW_TO_WINDOW|PFD_SUPPORT_OPENGL|PFD_DOUBLEBUFFER;
    pfd.iPixelType=PFD_TYPE_RGBA;
    pfd.cColorBits=(BYTE)bi.bmBitsPixel;
    pfd.cDepthBits=24;

    pfi=ChoosePixelFormat(hdc,&pfd);
    DescribePixelFormat(hdc,pfi,sizeof(PIXELFORMATDESCRIPTOR),&pfd);
    SetPixelFormat(hdc,pfi,&pfd);

    rc=wglCreateContext(hdc);

    if(rc==NULL) {
        if(flag1==0) {
            flag1=1;
            UserInt::informUser("RC creation failed.");
        }
    }

    return rc;
}

void OpenGLError(void) {
    switch(glGetError()) {
        case GL_INVALID_ENUM:
            UserInt::updateStatusBar("GL_INVALID_ENUM",0,0);
            break;
        case GL_INVALID_OPERATION:
            UserInt::updateStatusBar("GL_INVALID_OPERATION",0,0);
            break;
    }
}

void Vec2::glPlot() { glVertex2f(u,v); }

void Vec3::glPlot() { glVertex3f(x,y,z); }

void Vec3::glNormal() { glNormal3f(x,y,z); }

void Vec3::glRasterPos() { glRasterPos3f(x,y,z); }

void Matrix::loadIntoOpenGL() {
    float im[16];

    im[0 ]=x.x;
    im[1 ]=x.y;
    im[2 ]=x.z;
    im[3 ]=0.0;

    im[4 ]=y.x;
    im[5 ]=y.y;
    im[6 ]=y.z;
    im[7 ]=0.0;

    im[8 ]=z.x;
    im[9 ]=z.y;
    im[10]=z.z;
    im[11]=0.0;

    im[12]=l.x;
    im[13]=l.y;
    im[14]=l.z;
    im[15]=1.0f;

    glMatrixMode(GL_MODELVIEW);
    glLoadMatrixf(im);
}

void drawDart() {
    glShadeModel(GL_FLAT);
    glEnable(GL_NORMALIZE);
    glBegin(GL_TRIANGLE_FAN);
    glVertex3f(0.0f,0.0f,0.0f);
    glVertex3f(-.125f,-.125f,.125f);
    glNormal3f(-.707,0.0f,-.707f);
    glVertex3f(-.125f, .125f,.125f);
    glNormal3f(  0.0f, .707,-.707f);
    glVertex3f( .125f, .125f,.125f);
    glNormal3f( .707,0.0f,-.707f);
    glVertex3f( .125f,-.125f,.125f);
    glNormal3f(  0.0f,-.707,-.707f);
    glVertex3f(-.125f,-.125f,.125f);
    glEnd();

    glBegin(GL_TRIANGLE_FAN);
    glVertex3f(0.0f,0.0f,1.0f);
    glVertex3f(-.125f,-.125f,.125f);
    glNormal3f( 0.0f, -.990, .141f);
    glVertex3f( .125f,-.125f,.125f);//
    glNormal3f( .990,0.0f,.141f);
    glVertex3f( .125f, .125f,.125f);
    glNormal3f( 0.0f,  .990, .141f);
    glVertex3f(-.125f, .125f,.125f);//
    glNormal3f(-.990,0.0f,.141f);
    glVertex3f(-.125f,-.125f,.125f);
    glEnd();
}

/*
GLList::GLList() : first(0) { }

void GLList::nuke() {
    if (first!=0) glDeleteLists(first,range);
    first=0;
}

GLList::~GLList() {
    nuke();
}

bool GLList::set(GLsizei newrange) {
    nuke();
    first=glGenLists(newrange);
    range=newrange;
    return (first!=0);
}

GLuint  GLList::get(int index) {
    return first+index;
}
*/
