// parser.h -- declares the Parser class

// the parser class is designed to receive a C-string at construction time and
// to pass out various fields in it.

#ifndef PARSER_H
#define PARSER_H

#include <windows.h>
#include "lsmtypes.h"

class Parser {
        private:
                char*   buff;
                bool    good;
                int     ptr;
                int             len;
        public:
                Parser(char*);  // always constructed using supplied set of characters
                                                // to parse
//              ~Parser();
                bool    compareToken(char*);
                void    skipToken();
                void    skipWhiteSpace();
                INDEX   getIndex();
                float   getFloat();
                char*   getString();
                char    getChar();
                bool    getBool();
                bool    isValid();
                void    parseOBJCorner(INDEX&,INDEX&,INDEX&);
                void    reset();
};

inline bool Parser::isValid() { return good; }

#endif
