#include "userint.h"
#include "project.h"
#include "appdata.h"
#include "funcs.h"
#include "mouse.h"

// definition of static members of Project class
List Project::allProjects;
Project* Project::activeProject = 0;

//extern HWND hwndMain;
//extern HMENU LameMenu;

Project::~Project() {
    if(activeProject==this) activeProject=NULL;
    remove();
    if(SaveTitle) { delete []SaveTitle; SaveTitle=NULL; }
    if(SavePath) { delete []SavePath; SavePath=NULL; }
    if(ExportTitle) { delete []ExportTitle; ExportTitle=NULL; }
    if(ExportPath) { delete []ExportPath; ExportPath=NULL; }
}

Project::Project()
        : SaveTitle((char*)0)
        , SavePath((char*)0)
        , ExportTitle((char*)0)
        , ExportPath((char*)0)
        , currentVersion(0)
        , highVersion(0)
        , focusRectValid(false)
        , projectFlags(PF_SHOWAXES)
        , MouseMode(MM_NOTHING)
        , UserScale(1.0f)
        , UserRotate(0.0f)
        , UserTranslate(0.0f)
{
        allProjects.addHead(this);
}

//void Project::activate() { }

void Project::activateNext() {
    Project* p;

    if(activeProject==0) return;

    p=(Project*)activeProject->next();
    if(p==0) return;

    p->activate();
    

//    if(allProjects.first()!=allProjects.last()) {
//        p=(Project*)(Project::allProjects.first());
//        if(p) {
//            p->remove();
//            Project::allProjects.addTail(p);
//            activateFirst();
//        }
//    }
}

void Project::activatePrev() {
    Project* p;

    if(activeProject==0) return;

    p=(Project*)activeProject->prev();
    if(p==0) return;

    p->activate();

//      p->saveView();

//    if(allProjects.first()!=allProjects.last()) {
//        p=(Project*)(Project::allProjects.last());
//        if(p) {
//            p->remove();
//            Project::allProjects.addHead(p);
//            activateFirst();
//        }
//    }
}

void Project::activateFirst() {
        if(allProjects.first()) {
                ((Project*)(allProjects.first()))->activate();
        } else {
                activateProject(NULL);
        }
}

void Project::activateProject(Project* p) {

        if(activeProject) activeProject->saveView();

        activeProject=p;

        if(p==NULL) {
                SetMenu(UserInt::hwndMain,UserInt::LameMenu);
                InvalidateView();
        } else {
                p->remove();
                allProjects.addHead(p);
                p->activate();
        }
}

bool Project::destroyAllProjects(void) {
        activeProject=NULL;

        while(allProjects.first()) {
                delete (Project*)(allProjects.first());
        }

        return true;
}

void Project::closeActiveProject(void) {
        if(activeProject) delete activeProject;

        activateFirst();
}

HMENU Project::getPopupMenu() { return (HMENU)0; }

void Project::saveView() { }

bool Project::isUniqueProjectName(char *n) {
        Project* p;

        for(p=(Project*)(allProjects.first());p;p=(Project*)p->next())
        if(p->name==n) return false;

        return true;
}

void Project::setWindowTitle(HWND hwnd,Project*p) {
        char BaseTitleString[]="The LionSnake Modeler";
//        char *s1,*s2;

        if(p==NULL) {
                SetWindowText(hwnd,BaseTitleString);
        } else {
                p->setWindowTitle(hwnd);
        }
}

void Project::updateMenu() { }
void Project::updateToolBar() { }

