// model_c.cpp -- implements Model member functions starting with 'c'

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include "scene.h"
#include "appdata.h"
#include "fhand.h"
//#include "dialex.h"
#include "funcs.h"
//#include "mouse.h"
#include "lsmtypes.h"
#include "lsmres.h"
#include "obvec.h"

//#define SELBUFFSIZE 512
//#define MINIBUFFSIZE    4
//#define GADBUFFSIZE 64

//extern HINSTANCE hInst;
//extern HWND hwndMain;

/* re-write to be Scene member function
void Model::checkHighlight(int hi_flags) {
    GLuint *selbuff;
    GLint vp[4];
    short NewType,HitType;
    MYPTR NewItem;
    INDEX i,j;
    MYPTR m;
    UINT hits;
    unsigned int cmin,hmin,cmax,hmax;
    unsigned int skip;
    char buff[128];

// make space for the select buffer
    selbuff=new GLuint[SELBUFFSIZE];

    if(selbuff==NULL) {
        UpdateStatusBar("Selection buffer allocation failed.",0,0);
        return;
    }

// clear out or preserve current highlight, depending on what's needed
    if(hi_flags&HT_CLEAR) { // discard if not the current item
        NewType=HT_NOTHING;
        NewItem.e=NULL;
    } else { // discard only if replaced by another
        NewType=HighType;
        NewItem.e=HighItem.e;
    }

// set up select mode
// prepare the selection buffer
    glSelectBuffer(SELBUFFSIZE,selbuff);

// ensure that all objects are drawn correctly
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

// get the viewport
    glGetIntegerv(GL_VIEWPORT,vp);

// now go into projection mode
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
// set up clipping region
    glLoadIdentity();
    gluPickMatrix((GLdouble)lX,(GLdouble)(vp[3]+vp[1]-lY+cView.Screen.top),(GLdouble)7,(GLdouble)7,vp);
    cView.loadIntoOpenGL(vp[2],vp[3]);

// go into selection mode
    glRenderMode(GL_SELECT);

// prepare name stack
    glInitNames();
    glPushName((GLuint)0);

// search faces
    if(((hi_flags&HT_FACE)!=0) && ((modelFlags&MF_SHOW_FACES)!=0)) {
        glDisable(GL_CULL_FACE);
        glLoadName((GLuint)HT_FACE);
        glPushName((GLuint)0);
        STEPFACES(this,m.f)
        if((m.f->flags&TF_HIDDEN)==0) {
            glLoadName((GLuint)m.f);
// render the face
            glBegin(GL_POLYGON);
            for(int i=0;i<m.f->data.sides;i++)
            m.f->data.verts[i]->data.Spot.glPlot();
            glEnd();
        }
        glPopName();
    }

// search edges
    if(((hi_flags&HT_EDGE)!=0) && ((modelFlags&MF_SHOW_EDGES)!=0)) {
        glLoadName((GLuint)HT_EDGE);
        glPushName((GLuint)0);
        STEPEDGES(this,m.e)
//              if((m.e->flags&TF_INVALID)==0)
        if((m.e->flags&TF_HIDDEN)==0) {
            glLoadName((GLuint)m.e);
// render the edge
            glBegin(GL_LINES);
            m.e->data.VertS->data.Spot.glPlot();
            m.e->data.VertE->data.Spot.glPlot();
            glEnd();
        }
        glPopName();
    }

    bool showsubd=modelFlags&MF_SHOW_SUBD;
// search vertices
    if(((hi_flags&HT_VERT)!=0) && ((modelFlags&MF_SHOW_VERTS)!=0)) {
        glLoadName((GLuint)HT_VERT);
        glPushName((GLuint)0);
        STEPVERTS(this,m.v)
//      if((m.v->flags&TF_INVALID)==0)
//        if((m.v->flags&TF_HIDDEN)==0)
        if(m.v!=drag.v) {
            glLoadName((GLuint)m.v);
// render the vertex
            glBegin(GL_POINTS);
            m.v->draw(showsubd);
            glEnd();
        }
        glPopName();
    }

    if((hi_flags&HT_UVPT)!=0) {
        glLoadName((GLuint)HT_UVPT);
        glPushName((GLuint)0);
        STEPUVPTS(this,m.u)
        if(m.u->flags&TF_NEW)
        if(m.u!=drag.u) {
            glLoadName((GLuint)m.u);
// render the uv point
            glBegin(GL_POINTS);
            m.u->data.Spot.glPlot();
            glEnd();
        }
        glPopName();
    }

// select the bones
        if(((hi_flags&HT_BONE)!=0) && ((modelFlags&MF_SHOW_PARTS)!=0)) {
            glLoadName((GLuint)HT_BONE);
            glPushName((GLuint)0);
            STEPBONES(this,m.b)
            if(m.b!=drag.b) {
                glLoadName((GLuint)m.b);
                m.b->selectBase(getBoneLength(*m.b));
            }
            glPopName();

            glLoadName((GLuint)HT_KNOB);
            glPushName((GLuint)0);
            STEPBONES(this,m.b)
            if(m.b!=drag.b) {
                glLoadName((GLuint)m.b);
                m.b->selectEnd(getBoneLength(*m.b));
            }
            glPopName();
        }

        glPopName();

        hits=glRenderMode(GL_RENDER);

        hmin=0xffffffff;
        hmax=0xffffffff;

        j=0;
        HitType=HT_NOTHING;
        while(hits>0 && j<SELBUFFSIZE) {
            skip=selbuff[j++];      // get count of names
            cmin=selbuff[j++];      // get shallow end of hit
            cmax=selbuff[j++];  // get deep end of hit
            while(skip) {
                if((selbuff[j]>(UINT)HitType && cmin<=hmax && cmax>=hmin) // overlapped by higher priority item
                    || cmax<hmin ) { // closer item found
                    HitType=(short)selbuff[j];
                    i=selbuff[j+1];
                    hmin=cmin;
                    hmax=cmax;
                }
                j+=2;
                skip-=2;
            }
            hits--;
        }

        if(HitType!=HT_NOTHING) {
            NewItem.u=(UVPt*)i;
            NewType=HitType;
            if(NewItem.u!=HighItem.u || NewType!=HighType) InvalidateView();
        }

        HighType=NewType;
        HighItem.e=NewItem.e;
        if(HighItem.e==NULL) HighType=HT_NOTHING;

// restore old viewing matrix
        glMatrixMode(GL_PROJECTION);
        glPopMatrix();

        switch(HighType) {
        case HT_BONE:
                if(HighItem.b->data.Name.len()) {
                        sprintf(buff,"Bone: %s",HighItem.b->data.Name.c_string());
                        UpdateStatusBar(buff,0,0);
                }
        break;
        case HT_VERT:
                // do nothing
        break;
        case HT_EDGE:
                if(HighItem.e->sharpType()) {
                        UpdateStatusBar("This edge is sharp",0,0);
                } else {
                        UpdateStatusBar("",0,0);
                }
        break;
        default:
                        UpdateStatusBar("",0,0);
        break;
        }

        delete []selbuff;
}
*/

/* re-write to be Scene member
short Model::checkGadget() {
    Array<GLuint> selbuff(GADBUFFSIZE);
    GLint vp[4];
    short retval=MM_GADNULL;

    if(!selbuff) {
        UpdateStatusBar("Selection buffer creation failed.",0,0);
        return retval;
    }

// ensure that all objects are drawn correctly
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

// set up select mode
// prepare the selection buffer
    glSelectBuffer(GADBUFFSIZE,selbuff);

// get the viewport
    glGetIntegerv(GL_VIEWPORT,vp);

// now go into projection mode
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
// set up clipping region
    glLoadIdentity();
    gluPickMatrix((GLdouble)lX,(GLdouble)(vp[3]+vp[1]-lY+cView.Screen.top),(GLdouble)5,(GLdouble)5,vp);
    cView.loadIntoOpenGL(vp[2],vp[3]);

// go into selection mode
    glRenderMode(GL_SELECT);
// prepare name stack
    glInitNames();
    glPushName((GLuint)MM_GADNULL);
// render the gadget
    if(gadget) gadget->select();

    int hits=glRenderMode(GL_RENDER);

    if(hits) {
        int skip;
        unsigned int cmin,cmax;
        unsigned int hmin=0xffffffff;
        unsigned int hmax=0xffffffff;

        int j=0;
        while(hits>0 && j<GADBUFFSIZE) {
            skip=selbuff[j++];  // get count of names
            cmin=selbuff[j++];  // get shallow end of hit
            cmax=selbuff[j++];  // get deep end of hit
            while(skip) {
                if(cmin < hmin ) { // closer item found
                    retval=(short)selbuff[j];
                    hmin=cmin;
                    hmax=cmax;
                }
                j++;
                skip--;
            }
            hits--;
        }
    }

// done with the name stack
    glPopName();

// restore old viewing matrix
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();

    return retval;
}
*/

/* re-write to be Scene member function
void Model::checkSelectBox(RECT *box,short sel_flags) {
        GLuint *selbuff;
        GLint vp[4];
        MYPTR m;
        bool showsubd=modelFlags&MF_SHOW_SUBD;

// make space for the select buffer
        selbuff=new GLuint[MINIBUFFSIZE];

        if(selbuff==NULL) {
                UpdateStatusBar("Selection buffer creation failed.",0,0);
                return;
        }

// set up select mode
// prepare the selection buffer
        glSelectBuffer(MINIBUFFSIZE,selbuff);

// get the viewport
        glGetIntegerv(GL_VIEWPORT,vp);

// now go into projection mode
        glMatrixMode(GL_PROJECTION);
        glPushMatrix();
// set up clipping region
        glLoadIdentity();
        gluPickMatrix(
                ((GLdouble)box->left+(GLdouble)box->right)*.5,
                (GLdouble)vp[3]+(GLdouble)cView.Screen.top+(GLdouble)vp[1]-((GLdouble)box->bottom+(GLdouble)box->top)*.5,
                (GLdouble)(box->right-box->left),
                (GLdouble)(box->bottom-box->top),
                vp);
        cView.loadIntoOpenGL(vp[2],vp[3]);

// search vertices
        if(((sel_flags&HT_VERT)!=0) && ((modelFlags&MF_SHOW_VERTS)!=0)) {
                STEPVERTS(this,m.v)
//              if((m.v->flags&TF_INVALID)==0)
                if((m.v->flags&TF_HIDDEN)==0)
                if(m.v!=drag.v) {
                        if(m.v->flags&TF_DRAGGED) {
                                m.v->flags|=TF_MARKED;
                        } else {
                                m.v->flags&=~TF_MARKED;
                        }
// go into selection mode
                        glRenderMode(GL_SELECT);
// prepare name stack
//                      glInitNames();
// used by all objects
//                      glPushName((GLuint)0);
// render the vertex
            glBegin(GL_POINTS);
            m.v->draw(showsubd);
            glEnd();
//      done
//                      glPopName();
                        if(glRenderMode(GL_RENDER)) m.v->flags^=TF_MARKED;
                }
        }
        glMatrixMode(GL_PROJECTION);
        glPopMatrix();
        delete [](selbuff);

        MarkType=HT_VERT;
        applyMarkLogic();
}
*/

void Scene::clearAll() { }

/*
void Model::clearAllDragging() {
        MYPTR mp;

        STEPVERTS(this,mp.v) mp.v->flags&=~TF_DRAGGED;
}

void Model::clearHighlight() {
        HighItem.b=(Bone*)0;
        HighType=HT_NOTHING;
}
*/

/*
void Model::copyMarked() {
        Vert *v,*nv;
        Edge *e,*ne;
        Face *f,*nf;

// copy vertices
        STEPVERTS(this,v)
        if(v->flags&TF_MARKED) {
                v->Copy=nv=newVert(0,0);
                nv->data.Spot=v->data.Spot;
                nv->flags=TF_NEW;
        } else {
                v->Copy=NULL;
                v->flags&=~TF_NEW;
        }

// copy marked edges
        STEPEDGES(this,e)
        if(e->flags & TF_MARKED) {
                ne=newEdge(e->data.VertS->Copy,e->data.VertE->Copy);
                ne->setSharpLevel(e->getSharpLevel());
        }

// copy marked faces
        STEPFACES(this,f) {
                if(f->flags & TF_MARKED)
                nf=copyFace(f);
        }

        STEPVERTS(this,v) v->flags&=~TF_MARKED;

        STEPVERTS(this,v)
        if(v->Copy)
        v->Copy->flags|=TF_MARKED;

        applyMarkLogic();

        validate();
        validateMapping();
        takeSnap();
        modelFlags|=MF_BUILD_SUBD;
        InvalidateView();
}
*/

Scene*  Scene::createScene(HWND /*hwnd*/) {
        Scene*  scene;
//        Dialex *dx;
        char*   newName;
//        fReader file;

//        dx=new Dialex;

        newName=createSceneName();
        scene=(Scene*)0;

//        dx->setDialogString(EB_NAME,newName);
//        if(newName) { delete []newName; newName=(char*)0; }
//        dx->setDialogString(EB_MESHFILE,(char*)0);
//        dx->setDialogString(EB_TEXTUREFILE,(char*)0);
//      dx->setDialogString(EB_SKELETONFILE,(char*)0);
//        if(DialogBoxParam(AppData::hInst,MAKEINTRESOURCE(DLG_NEWMODEL),hwnd,
//                CreateModelDlg,(LPARAM)dx)==IDOK) {

                scene=new Scene;
                if(scene) {
//                        scene->name.own(dx->getDialogString(EB_NAME));
                        scene->name.own(newName);

// example of loading a file if one were named in the creation dialog
                        scene->projectFlags&=~PF_NOTDEFAULTNAME;
                        scene->activate();
                        Project::redoDisplay(scene);
                        scene->zoomToFit();
                }
//        }
//        delete dx;

        return scene;
}

char* Scene::createSceneName() {
    char tbuff[20];
    char *newName;
    int i;

    for(i=1,newName=NULL;newName==NULL;i++) {
        sprintf(tbuff,"Scene%d",i);
        if(Project::isUniqueProjectName(tbuff)) newName=CloneString(tbuff);
    }
    return newName;
}

