#include "userint.h"
#include <stdio.h>
#include <string.h>
#include "project.h"
#include "bone.h"
#include "part.h"
#include "funcs.h"

char *CloneString(char *s) {
        char *ns;

//      ReportSystemError("Cloning a string");

        if(s==NULL) {
                return NULL;
        }

        ns=new char[strlen(s)+1];
        if (ns) {
                strcpy(ns,s);
                ns[strlen(s)]=0;
        } else {
                UserInt::informUser("Could not allocate string");
        }
        return ns;
}

// removes unnecessary characters from floating-point strings
void FatFarm(char *s) {
        unsigned int i;
        int p;

        p=-1;
        for (i=0;i<strlen(s);i++) {
                if (s[i]=='E') return; // we don't touch sci notation
                if (s[i]=='e') return; // we don't touch sci notation
                if (s[i]=='.') p=i;
        }
        if (p==-1) return; // there is no decimal

        // strip trailing zeros
        while (s[strlen(s)-1]=='0') s[strlen(s)-1]=0;

        // strip trailing decimal
        if(s[strlen(s)-1]=='.') s[strlen(s)-1]=0;
}

void CopyString(char *s,char *d) {
        short i;

        if(s==0 || d==0) return;

        i=0;
        do {
                d[i]=s[i];
                i++;
        } while(s[i-1]!=0);
}

char *ConcatStrings(char *a,char *b) {
        int la;
        char *s;

        la=strlen(a);

        s=new char[la+strlen(b)+1];

        strcpy(s,a);
        strcpy(s+la,b);
        return s;
}

void ScrubString(char *src,char find,char replace,char *dst) {
    int i;
    int j;

    for(i=0,j=0;src[i]!=0;i++) {
        if(src[i]==find) {
                dst[j]=replace;
                if(replace!=0) j++;
        } else {
                dst[j]=src[i];
                j++;
        }
    }
    dst[j]=0;
}

void replaceExtension(char*fileName,char*ext) {
        int i;
        int l=0;

        for(i=0;fileName[i];i++) {
            switch(fileName[i]) {
                case '.':
                  l=i;
                break;
                case '/':
                case '\\':
                  l=0;
            }
        }

        if(l==0) return;
        l++;
        for(i=0;ext[i];i++) {
            if(fileName[l]) fileName[l]=ext[i];
            l++;
        }
        if(fileName[l]) fileName[l]='\0';
}

int strCmp(char* a,char* b) {
        int i;

        if(a==NULL) {
                if(b==NULL) return 0;
                return -1;
        } else {
                if(b==NULL) return 1;
        }

        for(i=0;a[i]!=0 && b[i]!=0;i++)
        if(a[i]!=b[i]) return a[i]-b[i];

        return a[i]-b[i];
}
