#ifndef TINT_H
#define TINT_H

#include <windows.h>
#include <gl/gl.h>
#include "link.h"
#include "list.h"
#include    "mystr.h"

struct TintData {
        Mystr   Name;
        Mystr   File;
        COLORREF    color;

        bool operator!=(TintData&);
        void operator=(TintData&);
        TintData();
        ~TintData();
};

class  TintEntry : public Entry {
        public:
                TintData    data;
};


class Tint : public Thing {
        public:
        TintData    data;
        eList  history;
// the following must all be re-done whenever the File field changes
        HBITMAP hbm;
    short       sX,sY;  // size of bitmap
        GLubyte *bmBits;
        GLuint  glName; // OpenGL texture name

        Tint(bool isDefTint=false); // we have a default tint in the Model object
        ~Tint(); // which has dynamically-allocated data in it
        void buildTintBitmap(HDC);
        void    getTintBitmap();
        void selectIntoOpenGL(); // was selectTexture(Tint*);
        void deriveSolid();
        void    deleteInfo();   // force re-creation of the bitmap
        void    tintWindow(HWND);
        void    writeToFile(class fWriter&);

// undo/redo stuff
        void    clipHistory(INDEX);
        bool    takeSnap(INDEX);
        void    restoreVersion(INDEX);
        void    destroyHistory();
};

#endif
