#include "userint.h"
//#define _WIN32_IE 0x300
#include <commctrl.h>
#include "appdata.h"
#include "model.h"
#include "lsmres.h"
#include "mouse.h"

#define TB_COUNT 37

struct ButtonData {
        int bitmap;
        bool    use_file;
        int command;
        BYTE    state;
        BYTE    style;
} tb1[TB_COUNT]= {
        { STD_FILENEW,    false, IDM_NEWMODEL,  TBSTATE_ENABLED, TBSTYLE_BUTTON  },
        { STD_FILESAVE,   false, IDM_SAVEAS,    TBSTATE_ENABLED, TBSTYLE_BUTTON  },
        { STD_FILEOPEN,   false, IDM_OPEN,      TBSTATE_ENABLED, TBSTYLE_BUTTON  },
        { -1, false,  0, 0, TBSTYLE_SEP },
        { STD_UNDO,       false, IDM_UNDO,      0,               TBSTYLE_BUTTON  },
        { STD_REDOW,      false, IDM_REDO,      0,               TBSTYLE_BUTTON  },
        { -1, false,  0, 0, TBSTYLE_SEP },
        { STD_COPY,       false, IDM_COPY,      TBSTATE_ENABLED, TBSTYLE_BUTTON  },
        { STD_DELETE,     false, IDM_DELMARK,   TBSTATE_ENABLED, TBSTYLE_BUTTON  },
        { -1, false,  0, 0, TBSTYLE_SEP },
        { 0,              true,  IDM_SHOWVERTS, TBSTATE_ENABLED, TBSTYLE_CHECK   },
        { 1,              true,  IDM_SHOWEDGES, TBSTATE_ENABLED, TBSTYLE_CHECK   },
        { 2,              true,  IDM_SHOWFACES, TBSTATE_ENABLED, TBSTYLE_CHECK   },
        { 18,             true,  IDM_SHOWSUBD,  TBSTATE_ENABLED, TBSTYLE_CHECK   },
        { 3,              true,  IDM_SHOWPARTS, TBSTATE_ENABLED, TBSTYLE_CHECK   },
        { 4,              true,  IDM_SHOWAXES,  TBSTATE_ENABLED, TBSTYLE_CHECK   },
        { -1, false, 0, 0, TBSTYLE_SEP },
        { 5,              true,  IDM_FROML,     TBSTATE_ENABLED, TBSTYLE_BUTTON  },
        { 6,              true,  IDM_FROMR,     TBSTATE_ENABLED, TBSTYLE_BUTTON  },
        { 7,              true,  IDM_FROMU,     TBSTATE_ENABLED, TBSTYLE_BUTTON  },
        { 15,             true,  IDM_FROMD,     TBSTATE_ENABLED, TBSTYLE_BUTTON  },
        { 16,             true,  IDM_FROMF,     TBSTATE_ENABLED, TBSTYLE_BUTTON  },
        { 17,             true,  IDM_FROMB,     TBSTATE_ENABLED, TBSTYLE_BUTTON  },
        { -1, false, 0, 0, TBSTYLE_SEP },
        { 8,              true,  IDM_SELECT,    TBSTATE_ENABLED, TBSTYLE_CHECKGROUP      },
        { 9,              true,  IDM_PANVIEW,   TBSTATE_ENABLED, TBSTYLE_CHECKGROUP      },
        { 10,             true,  IDM_ZOOMVIEW,  TBSTATE_ENABLED, TBSTYLE_CHECKGROUP      },
        { 11,             true,  IDM_ROTVIEW,   TBSTATE_ENABLED, TBSTYLE_CHECKGROUP      },
        { 12,             true,  IDM_ADDVERT,   TBSTATE_ENABLED, TBSTYLE_CHECKGROUP      },
        { 13,             true,  IDM_ADDMESH,   TBSTATE_ENABLED, TBSTYLE_CHECKGROUP      },
        { 14,             true,  IDM_ADDBONE,   TBSTATE_ENABLED, TBSTYLE_CHECKGROUP      },
        { -1, false,  0, 0, TBSTYLE_SEP },
        { STD_PROPERTIES, false, IDM_MARK_PROP, 0,               TBSTYLE_BUTTON  },
        { -1, false,  0, 0, TBSTYLE_SEP },
        { 20,             true,  IDM_LOCK_X,    TBSTATE_ENABLED, TBSTYLE_CHECK   },
        { 21,             true,  IDM_LOCK_Y,    TBSTATE_ENABLED, TBSTYLE_CHECK   },
        { 22,             true,  IDM_LOCK_Z,    TBSTATE_ENABLED, TBSTYLE_CHECK   }
};

// CreateAToolBar creates a toolbar and adds a set of buttons to it.
// The function returns the handle to the toolbar if successful,
// or NULL otherwise.
// hwndParent is the handle to the toolbar's parent window.
HWND CreateAToolBar(HWND hwndParent,HINSTANCE hInst) {
   HWND hwndTB;
        TBBUTTON tbb;
   TBADDBITMAP tbab;
   INITCOMMONCONTROLSEX icex;
   int hr;
        int i;

// Ensure that the common control DLL is loaded.
   icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
   icex.dwICC  = ICC_BAR_CLASSES;
//   InitCommonControls();
   InitCommonControlsEx(&icex);

// Create a toolbar.
        hwndTB = CreateWindowEx(0, TOOLBARCLASSNAME, (LPSTR) NULL, WS_CHILD |
                TBSTYLE_TOOLTIPS | /*CCS_ADJUSTABLE |*/ TBSTYLE_WRAPABLE, 0, 0, 0, 0,
                hwndParent, (HMENU) ID_TOOLBAR, hInst, NULL);

// Send the TB_BUTTONSTRUCTSIZE message, which is required for
// backward compatibility.
        SendMessage(hwndTB, TB_BUTTONSTRUCTSIZE, (WPARAM) sizeof(TBBUTTON), 0);

        SendMessage(hwndTB, TB_SETBUTTONSIZE,0,(LPARAM)MAKELONG(24,22));

// add standard buttons
        tbab.hInst=HINST_COMMCTRL;
        tbab.nID=IDB_STD_SMALL_COLOR;
        SendMessage(hwndTB,TB_ADDBITMAP,0,(LPARAM) (LPTBADDBITMAP) &tbab );
// and my new ones
        tbab.hInst=hInst;
        tbab.nID=IDB_TOOLBAR;
        hr=SendMessage(hwndTB,TB_ADDBITMAP,(WPARAM)5,(LPARAM)(LPTBADDBITMAP)&tbab);

        memset(&tbb,0,sizeof(tbb));

        for(i=0;i<TB_COUNT;i++) {
                tbb.iBitmap=tb1[i].bitmap;
                if(tb1[i].use_file) tbb.iBitmap+=hr;
                tbb.idCommand=tb1[i].command;
                tbb.fsState=tb1[i].state;
                tbb.fsStyle=tb1[i].style;
                tbb.dwData=0;
                tbb.iString=-1;
                SendMessage(hwndTB, TB_ADDBUTTONS, (WPARAM) 1,(LPARAM) (LPTBBUTTON)&tbb);
        }

// lefotver code

//      LoadString(hInst, IDS_NEW, szBuf, MAX_LEN-1);
//   tbb[0].iString = -1;//SendMessage(hwndTB, TB_ADDSTRING, (WPARAM) 0, (LPARAM) (LPSTR) szBuf);

        SendMessage(hwndTB,TB_SETMAXTEXTROWS,0,0);
        SendMessage(hwndTB, TB_AUTOSIZE, 0, 0);
        ShowWindow(hwndTB, SW_SHOW);
        return hwndTB;
}

void Model::updateToolBar(void) {
    int i;
//      BOOL flag;
    char /*check[TB_COUNT],*/ enable[TB_COUNT];

    if(UserInt::hwndToolBar==(HWND)0) return;

    if(Project::activeProject==NULL) {
        for(i=0;i<TB_COUNT;i++) {
            enable[i]=0;
        }
        enable[0]=enable[2]=TBSTATE_ENABLED;
    } else {
        for(i=0;i<TB_COUNT;i++) {
            enable[i]=tb1[i].state;
        }
        switch(Project::activeProject->EditMode) {
//                      case EM_MESHEDIT:
//                      break;
                        case EM_MAPEDIT:
                                enable[17]=enable[18]=enable[19]=enable[20]=enable[21]=enable[22]=
                                enable[27]=enable[28]=enable[29]=enable[30]=enable[32]= 0;
                        break;
                }

                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_SHOWVERTS,
                        MAKELONG(modelFlags&MF_SHOW_VERTS,0));
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_SHOWEDGES,
                        MAKELONG(modelFlags&MF_SHOW_EDGES,0));
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_SHOWFACES,
                        MAKELONG(modelFlags&MF_SHOW_FACES,0));
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_SHOWPARTS,
                        MAKELONG(modelFlags&MF_SHOW_PARTS,0));
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_SHOWSUBD,
                        MAKELONG(modelFlags&MF_SHOW_SUBD,0));
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_SHOWAXES,
                        MAKELONG(projectFlags&PF_SHOWAXES,0));
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_LOCK_X,
                        MAKELONG(modelFlags&MF_LOCK_X,0));
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_LOCK_Y,
                        MAKELONG(modelFlags&MF_LOCK_Y,0));
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_LOCK_Z,
                        MAKELONG(modelFlags&MF_LOCK_Z,0));

                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_SELECT,0);
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_PANVIEW,0);
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_ZOOMVIEW,0);
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_ROTVIEW,0);
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_ADDVERT,0);
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_ADDMESH,0);
                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_ADDBONE,0);

                switch(MouseMode) {
                        case MM_PANVIEW0: case MM_PANVIEW1:
                                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_PANVIEW,MAKELONG(TRUE,0));
                        break;
                        case MM_ZOOMVIEW0: case MM_ZOOMVIEW1:
                                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_ZOOMVIEW,MAKELONG(TRUE,0));
                        break;
                        case MM_ROTVIEW0: case MM_ROTVIEW1:
                                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_ROTVIEW,MAKELONG(TRUE,0));
                        break;
                        case MM_ADDVERT:
                                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_ADDVERT,MAKELONG(TRUE,0));
                        break;
                        case MM_ADDMESH0: case MM_ADDMESH1: case MM_ADDMESH2:
                                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_ADDMESH,MAKELONG(TRUE,0));
                        break;
                        case MM_ADDBONE:
                                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_ADDBONE,MAKELONG(TRUE,0));
                        break;
                        default:
                                SendMessage(UserInt::hwndToolBar,TB_CHECKBUTTON,IDM_SELECT,MAKELONG(TRUE,0));
                        break;
                }

// set the undo/redo and properties buttons
                enable[4]=enable[5]=0;
                if(currentVersion > 0) enable[4]=TBSTATE_ENABLED;
                if(currentVersion < highVersion) enable[5]=TBSTATE_ENABLED;
                if(MarkType!=HT_NOTHING) enable[32]=TBSTATE_ENABLED;
        }
        for(i=0;i<TB_COUNT;i++)
        if(tb1[i].command)
        SendMessage(UserInt::hwndToolBar,TB_ENABLEBUTTON,tb1[i].command,MAKELONG(enable[i],0));
}

