// transform.h -- declares the Matrix and Transform classes

#ifndef TRANSFORM_H
#define TRANSFORM_H

#include "lsmtypes.h"
#include "calc.h"

struct Matrix {
    Vec3 x,y,z,l;
//        float e[12];
        Matrix();
        void identity();
        void mult(Matrix&);
        void mult(Matrix&,Matrix&);
//        void transform(Vec3&);
//        void transform(Vec3&,Vec3&);
        void invertUVector(Vec3&,Vec2&);
//        void invertVector(Vec3&,Vec3&);
        void invertMatrix(Matrix&);
        void setXVec(float,float,float);
        void setYVec(float,float,float);
        void setZVec(float,float,float);
        void setLVec(float,float,float);
//        Vec3& getXVec();
//        Vec3& getYVec();
//        Vec3& getZVec();
//        Vec3& getLVec();
        void invert(Matrix&);
//        float   get(unsigned int);
        void    loadIntoOpenGL();
    Matrix& operator*=(Matrix&);
    Matrix& operator/=(Matrix&);
    float det();
//        friend class Transform;
};

//inline float Matrix::get(unsigned int index) {
//        return e[index];
//}

inline void Matrix::setXVec(float sx,float sy,float sz) {
    x.x=sx;
    x.y=sy;
    x.z=sz;
}

inline void Matrix::setYVec(float sx,float sy,float sz) {
    y.x=sx;
    y.y=sy;
    y.z=sz;
}

inline void Matrix::setZVec(float sx,float sy,float sz) {
    z.x=sx;
    z.y=sy;
    z.z=sz;
}

inline void Matrix::setLVec(float sx,float sy,float sz) {
    l.x=sx;
    l.y=sy;
    l.z=sz;
}

//inline Vec3& Matrix::getXVec() { return x; }
//inline Vec3& Matrix::getYVec() { return y; }
//inline Vec3& Matrix::getZVec() { return z; }
//inline Vec3& Matrix::getLVec() { return l; }

struct Transform {
        Matrix fore,back;
//      Transform();
//        void transformVector(float*,float*);
//        void transformVector(float*,Vec3&);
//        void transformVector(Vec3&,float*);
//        void transformVector(Vec3&,Vec3&);
//        void invertVector(float*,float*);
//        void invertVector(float*,Vec3&);
//        void invertVector(Vec3&,float*);
//        void invertVector(Vec3&,Vec3&);
        void identity();
        void scaleBy(Vec3&);
        void rotateBy(Vec3&);
        void translateBy(Vec3&);
        void transformBy(Transform&);
        void    clearTranslate();
        void    buildInverse();
        void    loadIntoOpenGL() { fore.loadIntoOpenGL(); }
};

#endif
