// userint.cpp -- implements the UserInt class

#include "userint.h"
#include "lsmres.h"

HWND UserInt::hwndMain(0);
HINSTANCE UserInt::hInst(0);
HWND UserInt::hwndToolBar(0);
HWND UserInt::hwndStatusBar(0);
HGLRC UserInt::hrc(0);
HMENU UserInt::ModelMenu(0);
HMENU UserInt::SceneMenu(0);
HMENU UserInt::LameMenu(0);
HMENU UserInt::DelPopupMenu(0);
HMENU UserInt::ExtrudePopupMenu(0);
HMENU UserInt::CopyPopupMenu(0);
HFONT UserInt::AxisFont(0);

UserInt::UserInt(HINSTANCE hInstance) {
    hInst=hInstance;
    AxisFont=CreateFont(8,8,0,0,FW_DONTCARE,FALSE,FALSE,FALSE,
        DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
        DEFAULT_QUALITY,FF_MODERN|FIXED_PITCH,(LPCTSTR)"Courier");
    ModelMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDMODELMENU));
    LameMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDLAMEMENU));
    DelPopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPDEL));
    ExtrudePopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPEXT));
    CopyPopupMenu=LoadMenu(hInst,MAKEINTRESOURCE(IDPOPUPCOPY));
}

UserInt::~UserInt() {
    DeleteObject(UserInt::AxisFont);
    DestroyMenu(UserInt::ModelMenu);
    DestroyMenu(UserInt::LameMenu);
    DestroyMenu(UserInt::DelPopupMenu);
    DestroyMenu(UserInt::ExtrudePopupMenu);
    DestroyMenu(UserInt::CopyPopupMenu);
}

bool UserInt::createStatusBar(HWND hwndParent,char *initialText,int nrOfParts) {
    hwndStatusBar = CreateStatusWindow(WS_CHILD | WS_VISIBLE | WS_BORDER|SBARS_SIZEGRIP,
        initialText,hwndParent,IDM_STATUSBAR);
    if(hwndStatusBar) {
        resizeStatusBar(hwndParent,nrOfParts);
        updateStatusBar(initialText,0,0);
        return true;
    }

    return false;
}

void UserInt::resizeStatusBar(HWND hwndParent,int nrOfParts) {
//    const cSpaceInBetween = 8;
    int   ptArray[40];   // Array defining the number of parts/sections
    RECT  rect;
    HDC   hDC;

   /* * Fill in the ptArray...  */

    hDC = GetDC(hwndParent);
    GetClientRect(hwndParent, &rect);

    ptArray[nrOfParts-1] = rect.right;
    //---TODO--- Add code to calculate the size of each part of the status
    // bar here.

    ReleaseDC(hwndParent, hDC);
    SendMessage(hwndStatusBar,SB_SETPARTS,nrOfParts,(LPARAM)(LPINT)ptArray);
}

void UserInt::updateStatusBar(LPSTR lpszStatusString, WORD partNumber, WORD displayFlags) {
    SendMessage(hwndStatusBar,SB_SETTEXT,partNumber | displayFlags,(LPARAM)lpszStatusString);
}

void UserInt::informUser(char *s) {
        MessageBoxEx(hwndMain,s,"Guess what?",MB_OK,LANG_NEUTRAL);
}

