#include <windows.h>
#include <math.h>
#include <gl\gl.h>
#include "vert.h"
#include "patch.h"
#include "edge.h"
#include "face.h"
#include "uvpt.h"
#include "funcs.h"
#include "calc.h"
#include "join.h"

// this function deleted for now, will be redone later when I can come up with
// a good general-purpose solution
//void Face::extendMapping(Edge* e,float *uv) {
// REQUIRES MASSIVE REWRITE
/*
        UVPt *uo,*up,*un;
        uvec temp;
        Face* of;

        if(this==NULL) return;
        if(e==NULL) return;
        if(uv==NULL) return;
        of=otherSide(e);
        if(of==NULL) return;

        if(of->data.VertD==NULL) { // triangle
                if(e==of->EdgeE) { uo=of->data.MapA; up=of->data.MapB; un=of->data.MapC; }
                if(e==of->EdgeF) { uo=of->data.MapB; up=of->data.MapC; un=of->data.MapA; }
                if(e==of->EdgeG) { uo=of->data.MapC; up=of->data.MapA; un=of->data.MapB; }
        } else { //quadrilateral
                if(e==of->EdgeE) { uo=of->data.MapA; up=of->data.MapB; un=of->data.MapD; }
                if(e==of->EdgeF) { uo=of->data.MapB; up=of->data.MapC; un=of->data.MapA; }
                if(e==of->EdgeG) { uo=of->data.MapC; up=of->data.MapD; un=of->data.MapB; }
                if(e==of->EdgeH) { uo=of->data.MapD; up=of->data.MapA; un=of->data.MapC; }
        }
        uv[U]=up->data.Spot[V]-uo->data.Spot[V];
        uv[V]=uo->data.Spot[U]-up->data.Spot[U];
    temp[U]=un->data.Spot[U]-uo->data.Spot[U];
    temp[V]=un->data.Spot[V]-uo->data.Spot[V];
        if(uv[U]*temp[U]+uv[V]*temp[V]>0) {
                uv[U]=-uv[U];
                uv[V]=-uv[V];
        }
*/
//}

UVPt::UVPt() {
    UVPtEntry* ue=new UVPtEntry;
    history.addTail(ue);
}

UVPt::~UVPt() {
    destroyHistory();
}

void UVPt::addJoin(Join* j) {
    if(joins.find(j)==-1)
    joins.append(j);
}

void UVPt::calcSubf() {
    switch(sharp1()) {
        case 0:
        case 1:
            subLevelf*=1.0f/((float)joins.pop());
            break;
        case 2:
            if(joins.pop()==2) {
                subLevelf=getSub1();
            } else {
                (subLevelf=getSub1())*=4.0;
                for(int i=0;i<joins.pop();i++) {
                    if(joins[i]->sharpType()) {
                        subLevelf+=joins[i]->getSub1();
                    }
                }
                subLevelf*=.1666666667;
            }
            break;
        default:
            subLevelf=getSub1();
    }
}


void UVPt::drawEdge(UVPt* ou) {
    if( ((int)this) > ((int)ou) ) {
        data.Spot.glPlot();
        ou->data.Spot.glPlot();
    } else {
        ou->data.Spot.glPlot();
        data.Spot.glPlot();
    }
}

Join* UVPt::findJoin(UVPt* ou) {
    for(int i=0;i<joins.pop();i++)
    if(joins[i]->UVPtS==ou || joins[i]->UVPtE==ou) return joins[i];

    return (Join*)0;
}

void UVPt::prepSub() {
    sharpCount1=borderCount=0;
}

void Face::pullUVData(Edge* e) {
        Face* of;
        UVPt* u;
        Vert *v;

        if(this==NULL) return; // invalid call
        if(e==NULL) return; // invalid call

        if(e->sharpType()) return; // no pull over sharp edges

        of=otherSide(e);
        if(of==NULL) return; // no pull over border edges

        if(!(of->data.uvpts)) return; // no pull from non-uvmapped faces

        if(data.Texture!=of->data.Texture) return; // no pull from face with a different texture

        u=NULL;
        v=e->data.VertS;
        for(int i=0;i<of->data.sides;i++)
        if(v==of->data.verts[i]) u=of->data.uvpts[i];

        for(int i=0;i<data.sides;i++)
        if(v==data.verts[i]) data.uvpts[i]=u;

        u=NULL;
        v=e->data.VertE;
        for(int i=0;i<of->data.sides;i++)
        if(v==of->data.verts[i]) u=of->data.uvpts[i];

        for(int i=0;i<data.sides;i++)
        if(v==data.verts[i]) data.uvpts[i]=u;
}

void UVPt::remJoin(class Join* j) {
    joins.remove(j);
}

void UVPt::snapUVPt(float f) {
    data.Spot.u=floorf(data.Spot.u/f+.5)*f;
    data.Spot.v=floorf(data.Spot.v/f+.5)*f;
}

// undo/redo functions

bool UVPt::takeSnap(INDEX newVersion) {
        UVPtEntry*      uh;
        UVPtEntry*      luh;
        bool make;
        TYPE    newType;

        // clip all history equal to or greater than new version
        clipHistory(newVersion);

        // most recent entry should be last
        luh=(UVPtEntry*)(history.last());

/* behavior logic:
for takeSnap():

last entry      current object
NONE            invalid                 flag as TF_KILLME
et_nul          invalid                 flag as TF_KILLME
et_chg          invalid                 archive as et_del
et_del          invalid                 do nothing

NONE            valid                   archive as et_chg
et_nul          valid                   archive as et_chg
et_chg          valid                   compare and archive as et_chg
et_del          valid                   shouldn't happen
*/

        make=false; // default is don't make new entry
        newType=ET_CHG; // most common type is change

        if(luh==NULL) {
                if(flags&TF_INVALID) {
                        flags|=TF_KILLME;
                } else {
                        make=true;
                }
        } else {
                switch(luh->type) {
                        case ET_NUL:
                                if(flags&TF_INVALID) {
                                        flags|=TF_KILLME;
                                } else {
                                        make=true;
                                        newType=ET_CHG;
                                }
                                break;
                        case ET_CHG:
                                if(flags&TF_INVALID) {
                                        make=true;
                                        newType=ET_DEL;
                                } else {
                                        // make it if latest is different from current
                                        if (memcmp(&luh->data,&data,sizeof(UVPtData))) make=true;
                                }
                                break;
// last case is either do nothing or shouldn't happen
//                      case ET_DEL:
//                              break;
                }
        }

        if(make) {
                uh=new UVPtEntry;
                history.addTail(uh);
                uh->version=newVersion;
                uh->type=newType;
                uh->data=data;
        }

        return make;
}

void UVPt::clipHistory(INDEX version) {
        UVPtEntry *ue;
        UVPtEntry *nue;

        ue=(UVPtEntry*)(history.first());
        while(ue!=NULL) {
                nue=(UVPtEntry*)(ue->next());
                if(ue->version>=version) {
                        ue->remove();
                        delete ue;
                }
                ue=nue;
        }
}

void UVPt::destroyHistory() {
        UVPtEntry*  ue;

        while(history.last()) {
                ue=(UVPtEntry*)(history.last());
                ue->remove();
                delete ue;
        }
}

void UVPt::restoreVersion(INDEX getVersion) {
        UVPtEntry*  ue;

        ue=(UVPtEntry*)(history.last());

// there is always an entry with version 0, so this should never back up
// such that ve==0
        while(ue->version > getVersion)
        ue=(UVPtEntry*)(ue->prev());

        if(ue->type==ET_CHG) {
                data=ue->data;
                flags&=~TF_INVALID;
        } else {
                flags|=TF_INVALID;
        }
}
