#ifndef UVPT_H
#define UVPT_H

//#include <windows.h>
#include "link.h"
#include "list.h"
#include    "obvec.h"
#include "join.h"
#include "wsum.h"
#include "pointer.h"
#include "calc.h"

struct UVPtData {
        Vec2 Spot;
};

class UVPtEntry : public Entry {
        public:
                UVPtData    data;
};

class UVPt : public Thing {
    protected:
        WSum2   subLevel1;
        Vec2    subLevelf;
        short   sharpCount1;
        short   borderCount;
    public:
        UVPtData        data;
        eList   history;
        ObVec<class Join*>    joins;
        Vec2    Save;
        UVPt();
        ~UVPt();

        void    addJoin(class Join*);
        void    drawEdge(UVPt*);
        Join*   findJoin(UVPt*);
        void    remJoin(class Join*);
        void    snap(float);
        void    snapUVPt(float);
        void    writeToFile(class fWriter&);

// subdivision preview stuff
        void    prepSub();
        short&  sharp1() { return sharpCount1; }
        short&  border() { return borderCount; }
        void    weightSub1(Vec2& v,float w=1.0f) { subLevel1.add(v,w); }
//        void    weightSub2(Vec2& v,float w=1.0f) { subLevel2.add(v,w); }
        void    setupCalc() { subLevel1.setup(); }
        void    calcSub1() { subLevel1.recalc(); }
        void    calcSubf();
        Vec2&   getSub1() { return subLevel1.result(); }
        Vec2&   getSubf() { return subLevelf; }

// undo/redo stuff
        void    clipHistory(INDEX);
        bool    takeSnap(INDEX);
        void    restoreVersion(INDEX);
        void    destroyHistory();
};

#endif
