#ifndef VERT_H
#define VERT_H

#include <windows.h>
#include "link.h"
#include "list.h"
#include "obvec.h"
#include "lsmtypes.h"
#include "pointer.h"
#include "wsum.h"

struct VertData {
        Vec3 Spot;
        class Bone*   Owner;
//      FLAGS   flags;

        VertData();
        bool operator!=(VertData&);
        VertData&   operator=(VertData&);
};

class  VertEntry : public Entry {
        public:
                VertData    data;
};

class Vert : public Thing {
    private:
        short   sharpCount1;
//        short   sharpCount2;
        short   borderCount;
        WSum3   subLevel1;
        Vec3   subLevelf;
    public:
        VertData    data;
        eList  history;
        Vec3             Save;
        short   Order;
        Vert    *Copy;
        ObVec<Edge*>    Edges;

        Vert();
        ~Vert();
        void    addEdge(Edge*);
        void    attachToBone(Bone*);
        void    detach();
        void    draw(bool);
        Edge*   findEdge(Vert*);
        void    remEdge(Edge*);
        void    saveLoc();
        void    snapToGrid(float);
        void    writeToFile(class fWriter&);
//      void    writeToOBJFile(HANDLE);

// subdivision preview stuff
        short&  border() { return borderCount; }
        short&  sharp1() { return sharpCount1; }
//        short&  sharp2() { return sharpCount2; }
        void    prepSub();
        void    setupCalc() { subLevel1.setup(); }
        void    weightSub1(Vec3& v,float w=1.0f) { subLevel1.add(v,w); }
//        void    weightSub2(Vec3& v,float w=1.0f) { subLevel2.add(v,w); }
        void    calcSub1() { subLevel1.recalc(); }
        void    calcSubf();
        Vec3&   getSub1() { return subLevel1.result(); }
        Vec3&   getSubf() { return subLevelf; }

// undo/redo stuff
        void    clipHistory(INDEX);
        bool    takeSnap(INDEX);
        void    restoreVersion(INDEX);
        void    destroyHistory();
};

inline void Vert::attachToBone(Bone* b) {
        data.Owner=b;
}

// used in Vert.data.flags
#define VF_LOCKED   1

// used in Vert.flags
//#define       TF_MARKED       1       // marked by the user for some reason
//#define       TF_DRAGGED      2       // needs to be redrawn with mouse move
//#define       TF_NEW          4       // created in current operation
//#define       TF_INVALID      8       // not valid due to delete/redo/undo operation
//#define       TF_KILLME   16  // to be destroyed during next sweep
//#define       TF_HIDDEN   32  // don't display this
#define VF_WITHB        64

#endif
