#ifndef VIEW_H
#define VIEW_H

#include <windows.h>
#include "transform.h"
#include "calc.h"

class lsmView {
        public:
            Matrix  Orient;
            float   Scale;
            short   Flags;
            RECT    Extent; // absolute coordinates of project
            RECT    Screen; // the visible portion
            int     sX,sY;
            int     sM;             // smaller of sX or sY
        lsmView();
        void jumpToOrigin();
        void loadIntoOpenGL(int,int);
        void mapScr2XYZ(short,short,Vec3&);
        void mapScr2UV(short,short,struct Vec2&);
        void    mapXYZ2UV(Vec3&,struct Vec2&);
        void drawAxes(bool);
        bool    tracePlane(float*,float*,float*,float*);
        bool    nearest2Line(float*,float*,float*,float*);
        void zoomInTenPercent();
        void zoomOutTenPercent();
        void zoomToBound(class Bound&);
        void ViewFromBack();
        void ViewFromDown();
        void ViewFromFront();
        void ViewFromLeft();
        void ViewFromRight();
        void ViewFromUp();
        void ViewUV();
};

#define VF_NONPARALLEL  1       // view is not parallel to the screen
#define VF_LEFTHANDED   0       // left-handed universe
#define VF_RIGHTHANDED  2       // right-handed view
#define VF_HANDMASK             2       //

//#define VT_MODEL      0       // edit model view
//#define       VT_UVMAP        1       // edit uv-mapping view
//#define       VT_SCENE        2       // scene layout mode


#endif

